<?php

function MonLabo_help_shortcode_members_list() {
    $to_display="";
    $to_display.='<h3>[members_list]</h3>';
    $options0=get_option( 'MonLabo_settings_group0' );
    if (isset($options0["MonLabo_uses_members_and_groups"]) && (intval($options0["MonLabo_uses_members_and_groups"])===1)) {
        $to_display.='<div style="float:right;"><p><strong>Rendu n°1</strong> (liste de tous les membres du laboratoire):</p>
        <p><a href="'.plugins_url( 'images/members_list.png', __FILE__ ).'"><img width="300" src="'.plugins_url( 'images/members_list.png', __FILE__ ).'" alt="exemple" /></a></p></div>
        <p><strong>Où l\'insérer&nbsp;?</strong> Sur une page d\'équipe où sur la page de la liste des membres du laboratoire.</p>
        <p><strong>Contenu généré</strong> : Liste des membres du labo où d\'une équipe.</p>
        <p><strong>Exemples d\'utilisation</strong>:</p>
        <ul>
        <li><em>[members_list]</em> : Affiche la liste de tous les membres de l\'équipe de la page en cours ou à défaut tous les membres du laboratoire. Ces membres sont séparés par catégories (Direction, Chercheurs permanents, Ingénieurs et techniciens, Posts doctorants et Étudiants).</li>
        <li><em>[members_list uniquelist="YES"]</em> : Affiche la liste de tous les membres du laboratoire par ordre alphabétique sans séparation de catégories.</li>
        <li><em>[members_list team="3"]</em> : Affiche la liste des membres de l\'équipe n°3. Ces membres sont séparés en deux catégories : Chef(s) d\'équipe(s) et Membres.</li>
        </ul>
        <p><strong>Options spécifiques à [members_list]</strong>:</p>
        <ul>
        <li><em>uniquelist="YES"</em> (facultatif) : Si mis à YES, ne distingue plus les chefs/cheffes d\'équipe, les directeurs/directrices ni les catégories (<em>NO</em> par défaut).</li>
        <li><em>display_direction="YES|NO"</em> (facultatif) : Ajoute une catégorie <em>direction</em> séparant les directeurs/directrices (pour les unités) ou les chefs/cheffes (pour les équipes) des autres membres (<em>YES</em> par défaut).</li>
        <li>person="x" (facultatif) : force l\'affichage des personnes d\'ID x (peut être une liste séparée par des virgules).</li>
        </ul>
        <p><strong>Options communes à [members_list], [members_table], [members_chart], [alumni_list], [alumni_table] et [alumini_chart]</strong>:</p>
        <div style="float:right;"><p><strong>Rendu n°2 </strong> (liste des membres d\'une équipe):</p>
        <p><a href="'.plugins_url( 'images/members_list2.png', __FILE__ ).'"><img width="300" src="'.plugins_url( 'images/members_list2.png', __FILE__ ).'" alt="exemple" /></a></p></div>
        <ul>
        <li><em>team="x"</em> (facultatif) : N\'affiche que les membres de l\'équipe n°x (paramètre rempli automatiquement sur une page d\'équipe)</li>
        <li><em>unit="x"</em> (facultatif) : N\'affiche que les membres de l\'unité n°x</li>
        <li><em>categories="x"</em> (facultatif) : N\'affiche que les membres de la catégorie x (laisser vide pour choisir toutes les catégories, sinon choisir parmi <em>'.implode(",",get_MonLabo_persons_categories()).'</em>)</li>
        </ul>
        <p><strong>Options à items multiples</strong>:</p>
        <ul>
        <li>Les options <em>team, unit, categories</em> peuvent être des choix multiples en séparant les items par une virgule.</li>
        </ul>
        <p><strong>Anciennes syntaxes</strong> [members_list_automatic](versions &lt;= 0.60) ou [get_members_list] (versions &lt;= 0.33)</p>
        <div style="clear:both"></div>
        ';
    } else {
        $to_display.='<p>Désactivé</p>';
    }
    return $to_display;
}

function MonLabo_help_shortcode_members_table() {
    $to_display="";
    $to_display.='<h3>[members_table]</h3>';
    $options0=get_option( 'MonLabo_settings_group0' );
    if (isset($options0["MonLabo_uses_members_and_groups"]) && (intval($options0["MonLabo_uses_members_and_groups"])===1)) {
        $to_display.='<div style="float:right;"><p><strong>Rendu n°1</strong> (liste de tous les membres du laboratoire):</p>
        <p><a href="'.plugins_url( 'images/members_table.png', __FILE__ ).'"><img width="300" src="'.plugins_url( 'images/members_table.png', __FILE__ ).'" alt="exemple" /></a></p></div>
        <p><strong>Où l\'insérer&nbsp;?</strong> Sur une page d\'équipe où sur la page de la liste des membres du laboratoire.</p>
        <p><strong>Contenu généré</strong> : Table des membres du labo où d\'une équipe.</p>
        <p><strong>Exemples d\'utilisation</strong>:</p>
        <ul>
        <li><em>[members_table]</em> : Affiche la liste de tous les membres de l\'équipe de la page en cours ou à défaut tous les membres de la structure. Ces membres sont séparés par catégories (Chercheurs permanents, Ingénieurs et techniciens, Posts doctorants et Étudiants).</li>
        <li><em>[members_table team="3" presentation="compact"]</em> : Affiche la liste compacte des membres de l\'équipe n°3. Ces membres sont séparés par catégories (Chercheurs permanents, Ingénieurs et techniciens, Posts doctorants et Étudiants).</li>
        </ul>
        <p><strong>Options spécifiques à [members_table] </strong>:</p>
        <ul>
        <li><em>presentation="normal|compact"</em> (facultatif) : Tableau complet ou résumé (<em>normal</em> par défaut).</li>
        <li><em>uniquelist="YES"</em> (facultatif) : Si mis à YES, ne distingue plus les chefs/cheffes d\'équipe, les directeurs/directrices ni les catégories (<em>NO</em> par défaut).</li>
        <li><em>display_direction="YES|NO"</em> (facultatif) : Ajoute une catégorie <em>direction</em> séparant les directeurs/directrices (pour les unités) ou les chefs/cheffes (pour les équipes) des autres membres (<em>YES</em> par défaut).</li>
        </ul>
        <p><strong>Options communes à [members_list], [members_table], [members_chart], [alumni_list], [alumni_table] et [alumini_chart]</strong>:</p>
        <div style="float:right;"><p><strong>Rendu n°2 </strong> (liste compacte des membres d\'une équipe):</p>
        <p><a href="'.plugins_url( 'images/members_table2.png', __FILE__ ).'"><img width="300" src="'.plugins_url( 'images/members_table2.png', __FILE__ ).'" alt="exemple" /></a></p></div>
        <ul>
        <li><em>team="x"</em> (facultatif) : N\'affiche que les membres de l\'équipe n°x (paramètre rempli automatiquement sur une page d\'équipe)</li>
        <li><em>unit="x"</em> (facultatif) : N\'affiche que les membres de l\'unité n°x</li>
        <li><em>categories="x"</em> (facultatif) : N\'affiche que les membres de la catégorie x (laisser vide pour choisir toutes les catégories, sinon choisir parmi <em>'.implode(",",get_MonLabo_persons_categories()).'</em>)</li>
        </ul>
        <p><strong>Options à items multiples</strong>:</p>
        <ul>
        <li>Les options <em>team, unit, categories</em> peuvent être des choix multiples en séparant les items par une virgule.</li>
        </ul>
        <div style="clear:both"></div>
        ';
    } else {
        $to_display.='<p>Désactivé</p>';
    }
    return $to_display;
}
function MonLabo_help_shortcode_members_chart() {
    $to_display="";
    $to_display.='<h3>[members_chart]</h3>';
    $options0=get_option( 'MonLabo_settings_group0' );
    if (isset($options0["MonLabo_uses_members_and_groups"]) && (intval($options0["MonLabo_uses_members_and_groups"])===1)) {
        $to_display.='<div style="float:right;">
        <p><strong>Rendu</strong> (liste de tous les membres du laboratoire):</p>
        <p><a href="'.plugins_url( 'images/members_chart.png', __FILE__ ).'"><img width="300" src="'.plugins_url( 'images/members_chart.png', __FILE__ ).'" alt="exemple" /></a></p>
        </div>
        <p><strong>Où l\'insérer&nbsp;?</strong> Sur la page de la liste des membres du laboratoire.</p>
        <p><strong>Contenu généré</strong> : Organigramme des membres du labo.</p>
        <p><strong>Exemples d\'utilisation</strong>:</p>
        <ul>
        <li><em>[members_chart]</em> : Affiche la liste de tous les membres du laboratoire. Ces membres sont séparés par catégories (Direction, Chercheurs statutaires, Ingénieurs et techniciens, Posts doctorants et Étudiants) en ligne et par équipe en colonne.</li>
        </ul>
        <p><strong>Options spécifiques à [members_chart]</strong>:</p>
        <ul>
        <li><em>display_direction="YES|NO"</em> (facultatif) : Ajoute une catégorie <em>direction</em> séparant les directeurs/directrices (pour les unités) ou les chefs/cheffes (pour les équipes) des autres membres (<em>YES</em> par défaut).</li>
        </ul>
        <p><strong>Options communes à [members_list], [members_table], [members_chart], [alumni_list], [alumni_table] et [alumini_chart]</strong>:</p>
        <ul>
        <li><em>team="x"</em> (facultatif) : N\'affiche que les membres de l\'équipe n°x (paramètre rempli automatiquement sur une page d\'équipe)</li>
        <li><em>unit="x"</em> (facultatif) : N\'affiche que les membres de l\'unité n°x</li>
        <li><em>categories="x"</em> (facultatif) : N\'affiche que les membres de la catégorie x (laisser vide pour choisir toutes les catégories, sinon choisir parmi <em>'.implode(",",get_MonLabo_persons_categories()).'</em>)</li>
        </ul>
        <p><strong>Options à items multiples</strong>:</p>
        <ul>
        <li>Les options <em>team, unit, categories</em> peuvent être des choix multiples en séparant les items par une virgule.</li>
        </ul>
        <div style="clear:both"></div>
        ';
    } else {
        $to_display.='<p>Désactivé</p>';
    }
    return $to_display;
}
function MonLabo_help_shortcode_alumni_list() {
    $to_display="";
    $to_display.='<h3>[alumni_list]</h3>';
    $options0=get_option( 'MonLabo_settings_group0' );
    if (isset($options0["MonLabo_uses_members_and_groups"]) && (intval($options0["MonLabo_uses_members_and_groups"])===1)) {
        $to_display.='<div style="float:right;"><p><strong>Rendu</strong> (liste de tous les anciens membres permanents du laboratoire):</p>
        <p><a href="'.plugins_url( 'images/alumni_list2.png', __FILE__ ).'"><img width="300" src="'.plugins_url( 'images/alumni_list2.png', __FILE__ ).'" alt="exemple" /></a></p></div>
        <p><strong>Où l\'insérer&nbsp;?</strong>  Sur une page d\'équipe ou une page quelconque.</p>
        <p><strong>Contenu généré</strong> : Liste des anciens membres du labo.</p>
        <p><strong>Exemples d\'utilisation</strong>:</p>
        <ul>
        <li><em>[alumni_list]</em> : Affiche la liste de tous les anciens membres du laboratoire.</li>
        <li><em>[alumni_list title="Former PhDs and Postdocs" categories="postdocs,students"]</em> : Affiche la liste de tous les anciens membres du laboratoire des catégories Doctorants et postdoctorants avec en titre Former PhDs and Postdocs.</li>
        </ul>
        <p><strong>Options spécifiques à [alumni_list] </strong>:</p>
        <ul>
        <li><em>title="y"</em> (facultatif) : Affiche le titre y avant la liste.</li>
        <li><em>years="y"</em> (facultatif) : Affiche les alumni avec les années de départ correspondantes (plage d\'années séparées par un tiret - ou liste d\'années séparées par une virgule).</li>
        </ul>
        <p><strong>Options communes à [members_list], [members_table], [members_chart], [alumni_list], [alumni_table] et [alumini_chart]</strong>:</p>
        <ul>
        <li><em>team="x"</em> (facultatif) : N\'affiche que les anciens membres de l\'équipe n°x (paramètre rempli automatiquement sur une page d\'équipe)</li>
        <li><em>unit="x"</em> (facultatif) : N\'affiche que les anciens membres de l\'unité n°x</li>
        <li><em>categories="x"</em> (facultatif) : N\'affiche que les anciens membres de la catégorie x (laisser vide pour choisir toutes les catégories, sinon choisir parmi <em>'.implode(",",get_MonLabo_persons_categories()).'</em>)</li>
        </ul>
        <p><strong>Options à items multiples</strong>:</p>
        <ul>
        <li>Les options <em>team, unit, categories</em> peuvent être des choix multiples en séparant les items par une virgule.</li>
        </ul>
        ';
    } else {
        $to_display.='<p>Désactivé</p>';
    }
    return $to_display;
}
function MonLabo_help_shortcode_alumni_table() {
    $to_display="";
    $to_display.='<h3>[alumni_table]</h3>';
    $options0=get_option( 'MonLabo_settings_group0' );
    if (isset($options0["MonLabo_uses_members_and_groups"]) && (intval($options0["MonLabo_uses_members_and_groups"])===1)) {
        $to_display.='
        <div style="float:right;"><p><strong>Rendu</strong>:</p>
        <p><a href="'.plugins_url( 'images/alumni_table.png', __FILE__ ).'"><img width="300" src="'.plugins_url( 'images/alumni_table.png', __FILE__ ).'" alt="exemple" /></a></p></div>
        <p><strong>Où l\'insérer&nbsp;?</strong> Pas d\'endroit spécifique nécessaire.</p>
        <p><strong>Contenu généré</strong> : Table des anciens membres du labo.</p>
        <p><strong>Exemples d\'utilisation</strong>:</p>
        <ul>
        <li><em>[alumni_table]</em> : Affiche la table de tous les anciens membres du laboratoire.</li>
        <li><em>[alumni_table title="Former PhDs and Postdocs" categories="postdocs,students"]</em> : Affiche la table de tous les anciens membres du laboratoire des catégories Doctorants et postdoctorants avec en titre Former PhDs and Postdocs.</li>
        </ul>
        <p><strong>Options spécifiques à [alumni_table]</strong>:</p>
        <ul>
        <li><em>title="y"</em> (facultatif) : Affiche le titre y avant la liste.</li>
        <li><em>years="y"</em> (facultatif) : Affiche les alumni avec les années de départ correspondantes (plage d\'années séparées par un tiret - ou liste d\'années séparées par une virgule).</li>
        </ul>
        <p><strong>Options communes à [members_list], [members_table], [members_chart], [alumni_list], [alumni_table] et [alumini_chart]</strong>:</p>
        <ul>
        <li><em>team="x"</em> (facultatif) : N\'affiche que les anciens membres de l\'équipe n°x (paramètre rempli automatiquement sur une page d\'équipe)</li>
        <li><em>unit="x"</em> (facultatif) : N\'affiche que les anciens membres de l\'unité n°x</li>
        <li><em>categories="x"</em> (facultatif) : N\'affiche que les anciens membres de la catégorie x (laisser vide pour choisir toutes les catégories, sinon choisir parmi <em>'.implode(",",get_MonLabo_persons_categories()).'</em>)</li>
        </ul>
        <p><strong>Options à items multiples</strong>:</p>
        <ul>
        <li>Les options <em>team, unit, categories</em> peuvent être des choix multiples en séparant les items par une virgule.</li>
        </ul>
        ';
    } else {
        $to_display.='<p>Désactivé</p>';
    }
    return $to_display;
}
function MonLabo_help_shortcode_alumni_chart() {
    $to_display="";
    $to_display.='<h3>[alumni_chart]</h3>';
    $options0=get_option( 'MonLabo_settings_group0' );
    if (intval($options0["MonLabo_uses_members_and_groups"])===1) {
        $to_display.='<div style="float:right;">
        <p><strong>Rendu</strong> (liste de tous les anciens membres du laboratoire):</p>
        <p><a href="'.plugins_url( 'images/alumni_chart.png', __FILE__ ).'"><img width="300"  src="'.plugins_url( 'images/alumni_chart.png', __FILE__ ).'" alt="exemple" /></a></p>
        </div>
        <p><strong>Où l\'insérer&nbsp;?</strong> Sur la page de la liste des membres du laboratoire.</p>
        <p><strong>Contenu généré</strong> : Organigramme des anciens membres du labo.</p>
        <p><strong>Exemples d\'utilisation</strong>:</p>
        <ul>
        <li><em>[members_chart]</em> : Affiche la liste de tous les anciens membres du laboratoire. Ces membres sont séparés par catégories (Direction, Chercheurs statutaires, Ingénieurs et techniciens, Posts doctorants et Étudiants) en ligne et par équipe en colonne.</li>
        </ul>
        <p><strong>Options spécifiques à [alumni_chart]</strong>:</p>
        <ul>
        <li><em>years="y"</em> (facultatif) : Affiche les alumni avec les années de départ correspondantes (plage d\'années séparées par un tiret - ou liste d\'années séparées par une virgule).</li>
        </ul>
        <p><strong>Options communes à [members_list], [members_table], [members_chart], [alumni_list], [alumni_table] et [alumini_chart]</strong>:</p>
        <ul>
        <li><em>team="x"</em> (facultatif) : N\'affiche que les anciens membres de l\'équipe n°x (paramètre rempli automatiquement sur une page d\'équipe)</li>
        <li><em>unit="x"</em> (facultatif) : N\'affiche que les anciens membres de l\'unité n°x</li>
        <li><em>categories="x"</em> (facultatif) : N\'affiche que les anciens membres de la catégorie x (laisser vide pour choisir toutes les catégories, sinon choisir parmi <em>'.implode(",",get_MonLabo_persons_categories()).'</em>)</li>
        </ul>
        <p><strong>Options à items multiples</strong>:</p>
        <ul>
        <li>Les options <em>team, unit, categories</em> peuvent être des choix multiples en séparant les items par une virgule.</li>
        </ul>
        <div style="clear:both"></div>
        ';
    } else {
        $to_display.='<p>Désactivé</p>';
    }
    return $to_display;
}
function MonLabo_help_shortcode_publications_list() {
    $to_display="";
    $to_display.='<h3>[publications_list]</h3>';
    $options0=get_option( 'MonLabo_settings_group0' );
    $options4=get_option( 'MonLabo_settings_group4' );
    $to_display.='<div style="float:right;"><p><strong>Rendus</strong>:</p>
            <p><a href="'.plugins_url( 'images/publications_list2.png', __FILE__ ).'"><img width="300" src="'.plugins_url( 'images/publications_list2.png', __FILE__ ).'" alt="exemple" /></a></p>
            <p><a href="'.plugins_url( 'images/publications_list.png', __FILE__ ).'"><img width="300" src="'.plugins_url( 'images/publications_list.png', __FILE__ ).'" alt="exemple" /></a></p></div>';
    $to_display.='<p><strong>Où l\'insérer&nbsp;?</strong><br /> - Sur une page identifiée (équipe, unité ou page d\'un personnel)<br /> - ou sur une page quelconque mais en étant contraint d\'utiliser des "options complémentaire" pour identifier manuellement les publications.</p>
    <p><strong>Contenu généré</strong> : Insère automatiquement les publications de l\'utilisateur ou de l\'équipe issues d\'une base de donnée extérieure qui peut être :<br />
    &nbsp;- soit <a href="http://hal.archives-ouvertes.fr/">HAL</a><br />
    &nbsp;- soit la <a href="'.$options4['MonLabo_DescartesPubmed_api_url'].'">base de donnée du serveur Descartes Publi (Biomédicale)</a> (activable sur la <a href="admin.php?page=MonLabo_config&amp;tab=tab_configPublications">page d\'option de publications</a>).</p>
    ';
        $to_display.='<p><strong>Exemples d\'utilisation</strong>:</p>';
        $to_display.='
        <ul>
            <li><em>[publications_list]</em> => Génère une liste de publications.</li>
            <li><em>[publications_list title="Mes publications à moi"]</em> => Ajoute ou change le titre initial.</li>';
        $to_display.='
            <li><em>[publications_list years="2012-9999"]</em> => Récupère les dernières publications jusqu\'en 2012.</li>
        </ul>
        ';
    $to_display.='
        <p><strong>Configuration préalable</strong>:</p>
        <p>Pour pouvoir interroger cette base de données extérieure, il faut au préalable indiquer dans MonLabo les identifiants des personnels, des équipes et éventuellement de la structure de la base de donnée extérieure :<br />
        Pour HAL (cf. <a href="https://aurehal.archives-ouvertes.fr/structure/"> module de consultation de la liste des structures/équipes.</a>):<br />
        &nbsp;- champs "ID HAL de l&apos;auteur" dans la <a href="admin.php?page=MonLabo_edit_members_and_groups&amp;tab=tab_one">liste des personnels</a> (rubrique "autres")<br />
        &nbsp;- champs "ID HAL de l&apos;équipe" dans la <a href="admin.php?page=MonLabo_edit_members_and_groups&amp;tab=tab_two">liste des équipes</a> (rubrique "autres")<br />
        &nbsp;- champs "ID HAL de la structure" dans la <a href="admin.php?page=MonLabo_config&amp;tab=tab_one">Coordonnées</a><br />
        Pour la base de donnée Descartes Publi:<br />
        &nbsp;- champs "ID d\'auteur Descartes Publi" dans la <a href="admin.php?page=MonLabo_edit_members_and_groups&amp;tab=tab_one">liste des personnels</a> (rubrique "autres")<br />
        &nbsp;- champs "ID d\'equipe Descartes Publi" dans la <a href="admin.php?page=MonLabo_edit_members_and_groups&amp;tab=tab_two">liste des équipes</a> (rubrique "autres")
        </p>
        <p>Si Les données ne sont pas renseignées pour le serveur Descartes Publi, les publications sont issues de HAL.</p>
        ';
    $to_display.='<p><strong>Options basiques</strong>:</p>';
    $to_display.='<ul>
                    <li><em>title="Mon titre personnel"</em> (facultatif) : Insère ou change le titre au début de la liste de publications.</li>';
    $to_display.='  <li><em>years="A"</em> (facultatif) : Récupère les publications de l\'année A (il est possible de pouvoir indiquer une plage d\'années en séparant deux valeurs par le carractère "-").</li>';
    $to_display.='</ul>';
    $to_display.='<p><strong>Options complémentaires</strong>:</p>';
    $to_display.='<ul>';
    $to_display.='  <li><em>persons="X,Y,Z"</em> (facultatif) : Force la récupération des publications pour les personnes n°X,Y et Z du plugin MonLabo (utiliser le carractère "*" pour demander les publications de toutes les personnes entrées dans MonLabo). Si cette option est utilisée, les options <em>teams</em> et <em>units</em> sont ignorées.</li>';
    $to_display.='  <li><em>teams="X,Y,Z"</em> (facultatif) : Force la récupération des publications pour les équipes n°X,Y et Z du plugin MonLabo (utiliser le carractère "*" pour demander les publications de toutes les équipes entrées dans MonLabo).</li>';
    $to_display.='  <li><em>units="X,Y,Z"</em> (facultatif) : Force la récupération des publications pour les unités n°X,Y et Z du plugin MonLabo (utiliser le carractère "*" pour demander les publications de toutes les unités entrées dans MonLabo).</li>';
/*        $to_display.='  <li><em>equipes_="X,Y,Z"</em> (facultatif) : Force la récupération des publications pour les équipes n°X,Y et Z du plugin MonLabo. Utiliser le carractère "*" pour demander toutes les publications de toutes les équipes entrées dans MonLabo.</li>';
(choix du n° pour <a href="'.$options4['MonLabo_DescartesPubmed_api_url'].'?html_teamslist">Descartes Publi</a> ou <a href="https://aurehal.archives-ouvertes.fr/structure/index">HAL</a>)*/
    $to_display.='  <li><em>lang="[fr|en]"</em> : Affiche les publications dans la langue indiquée (par défaut c\'est la langue de l\'interface de Wordpress).</li>';
    $to_display.='  <li><em>limit="L"</em> : Limite le nombre de publications affichées au nombre L.</li>';
    $to_display.='  <li><em>offset="O"</em> : <i>(ne marche pas avec HAL)</i> Décale l\'affichage de O publications et affiche les publications restantes.</li>';
    $to_display.='</ul>';
    $to_display.='<p><strong>Options expertes pour HAL</strong>:<a href="https://hal.archives-ouvertes.fr/"><img width="61" height="34" class="wp-image-8 alignright wp-post-image" src="'.plugins_url( 'images/hal.logo.png', __FILE__ ).'" alt="logo HAL" /></a></p>';
    $to_display.='<ul>';
    $to_display.='  <li><em>hal_struct="A;B;C"</em> (facultatif, écrase les paramètres <em>persons</em>, <em>teams</em> et <em>unit</em>) : Récupère les publications des structures au numéro HAL A, B et C (cf. <a href="https://aurehal.archives-ouvertes.fr/structure/">module HAL de consultation de la liste des structures/équipes</a>).</li>';
    $to_display.='  <li><em>hal_idhal="A;B;C"</em> (facultatif, écrase les paramètres <em>persons</em>, <em>teams</em> et <em>unit</em>) : Récupère les publications des auteurs qui ont pour idHAL A, B, C (cf. <a href="https://aurehal.archives-ouvertes.fr/author/index">module HAL de consultation des auteurs</a>).</li>';
    $to_display.='</ul>';
    $to_display.='<p><strong>Options expertes pour Descartes Publi</strong> : <img width="61" height="34" class="wp-image-8 alignright wp-post-image" src="'.plugins_url( 'images/DescartesPubli.logo.png', __FILE__ ).'" alt="logo DescartesPubli" /></p>';
    $to_display.='<ul>';
    $to_display.='<li><em>descartes_alias="Unnom P"</em> (facultatif, écrase les paramètres <em>persons</em>, <em>teams</em> et <em>unit</em>) : Récupère les publications comprenant comme auteur l\'alias indiqué (Souvent Nom et initiale du prénom).</li>';
    $to_display.='<li><em>descartes_auteurid="Z"</em> (facultatif, écrase les paramètres <em>persons</em>, <em>teams</em> et <em>unit</em>) : Récupère les publications de l\'auteur au numéro DescartesPubli n°Z (choix du n° <a href="'.$options4['MonLabo_DescartesPubmed_api_url'].'?html_userslist">ici</a>).</li>';
    $to_display.='<li><em>descartes_unite="X"</em> (facultatif, écrase les paramètres <em>persons</em>, <em>teams</em> et <em>unit</em>) : Récupère les publications de l\'unité au numéro DescartesPubli n°X. (choix du n° <a href="'.$options4['MonLabo_DescartesPubmed_api_url'].'?html_unitslist">ici</a>)</li>';
    $to_display.='<li><em>descartes_equipe="Y"</em> (facultatif, écrase les paramètres <em>persons</em>, <em>teams</em> et <em>unit</em>) : Récupère les publications de l\'équipe au numéro DescartesPubli n°Y (choix du n° <a href="'.$options4['MonLabo_DescartesPubmed_api_url'].'?html_teamslist">ici</a>). Utiliser le carractère "*" pour demander toutes les publications des équipes entrées dans MonLabo.</li>';
    $to_display.='<li><em>descartes_typepub="Type de publication"</em> (facultatif) : Récupère les publications du type indiqué (choix parmis les valeurs possibles:';
    $to_display.='    <em>*, pub_journaux, pub_livres, pub_chapitres, pub_theses, pub_rapports, pub_presse, pub_communications, pub_brevets</em>). Par défaut le type choisi est pub_journaux.</li>';
    $to_display.='<li><em>descartes_nohighlight</em> (facultatif, option sans paramètre) : Ne met pas en gras les alias des membre de l\'unité ou de l\'équipe sélectionnée. Par défaut, cette option sans paramètre est absente.</li>';
    $to_display.='<li><em>descartes_orga_types="[aucun|par_titre|par_publication]"</em> (facultatif) : Séléctionne la façon d\'afficher les changement de types de publications.  Par défaut vaut <em>par_titre</em>.</li>';
    $to_display.='<li><em>descartes_format="[html_default|html_hal]"</em> (facultatif) : Séléctionne la façon d\'afficher les publications. Par défaut vaut <em>html_default</em>.</li>';
    $to_display.='</ul>';
    $to_display.='<p><strong>Anciennes syntaxes</strong> : [publications_automatic] (versions &lt;= 0.60) ou [perso_publications_automatic] (versions &lt;= 0.33)</p>';

    return $to_display;
}
function MonLabo_help_shortcode_custom_publications_list() {
    $to_display="";
    $options4=get_option( 'MonLabo_settings_group4' );
    $to_display.='<h3>[custom_publications_list] (OBSOLÈTE)</h3>
    <p><strong>Où l\'insérer&nbsp;?</strong> Shortcode obsolète, les options sont désormais disponible dans [publications_list].</p>
    <p><strong>Contenu généré</strong> : Insère des publications issues directement d\'une base de donnée extérieure (<a href="'.$options4['MonLabo_DescartesPubmed_api_url'].'">Descartes Publi</a> ou <a href="http://hal.archives-ouvertes.fr/">HAL</a>).</p>
    <p><strong>Exemples d\'utilisation (OBSOLÈTE)</strong>:</p>
    <ul>
    <li><em>[custom_publications_list unite="10|8|6" years="2013-2016"]</em> => Affiche les publications Descartes publi de 2013 à 2016 pour les unités n°10, 8 et 6.</li>
    <li><em>[custom_publications_list idHal="6557,10555" years="2013"]</em> => Affiche les publications Hali de 2013 pour les personnes ayant comme ID Hal 6557 et 10555.</li>
    </ul>
    <p><strong>Options communes (OBSOLÈTE)</strong>:</p>
    <ul>
    <li><em>years="A"</em> : Récupère les publications de l\'année A (il est possible de pouvoir indiquer une plage d\'années en séparant deux valeurs par le carractère "-").</li>
    <li><em>lang="[fr|en]"</em> : Affiche les titres dans la langue indiquée.</li>
    </ul>
    <p><strong>Options pour HAL (OBSOLÈTE)</strong> : <a href="https://hal.archives-ouvertes.fr/"><img width="61" height="34" class="wp-image-8 alignright wp-post-image" src="'.plugins_url( 'images/hal.logo.png', __FILE__ ).'" alt="logo HAL" /></a></p>
    <ul>
    <li><em>struct="A;B;C"</em> (option remplacée dans [publication_list] par <em>hal_struct</em>): Récupère les publications des structures A, B et C (cf. <a href="https://aurehal.archives-ouvertes.fr/structure/"> module de consultation de la liste des structures/équipes.</a>).</li>
    <li><em>idHal="A;B;C"</em> (option remplacée dans [publication_list] par <em>hal_idhal</em>): Récupère les publications des auteurs A, B, C (cf. <a href="https://aurehal.archives-ouvertes.fr/author/index"> module de consultation des auteurs.</a>).</li>
    </ul>
    <p><strong>Options pour Descartes Publi (OBSOLÈTE)</strong> : <img width="61" height="34" class="wp-image-8 alignright wp-post-image" src="'.plugins_url( 'images/DescartesPubli.logo.png', __FILE__ ).'" alt="logo DescartesPubli" /></p>
    <ul>
    <li><em>alias="Unnom P"</em> (option remplacée dans [publication_list] par <em>descartes_alias</em>): Récupère les publications comprenant comme auteur l\'alias indiqué (Souvent Nom et initiale du prénom).</li>
    <li><em>auteurid="Z"</em> (option remplacée dans [publication_list] par <em>descartes_auteurid</em>): Récupère les publications de l\'auteur n°Z (choix du n° <a href="'.$options4['MonLabo_DescartesPubmed_api_url'].'?html_userslist">ici</a>).</li>
    <li><em>unite="X"</em> (option remplacée dans [publication_list] par <em>descartes_unite</em>): Récupère les publications de l\'unité n°X. (choix du n° <a href="'.$options4['MonLabo_DescartesPubmed_api_url'].'?html_unitslist">ici</a>)</li>
    <li><em>equipe="Y"</em> (option remplacée dans [publication_list] par <em>descartes_equipe</em>): Récupère les publications de l\'équipe n°Y (choix du n° <a href="'.$options4['MonLabo_DescartesPubmed_api_url'].'?html_teamslist">ici</a>). Utiliser le carractère "*" pour demander toutes les publications des équipes entrées dans MonLabo.</li>
    <li><em>type="Type de publication"</em> (option remplacée dans [publication_list] par <em>descartes_typepub</em>): Récupère les publications du type indiqué (choix parmis les valeurs possibles:
        <em>*, pub_journaux, pub_livres, pub_chapitres, pub_theses, pub_rapports, pub_presse, pub_communications, pub_brevets</em>). Par défaut le type choisi est pub_journaux.</li>
    <li><em>nohighlight</em> (option remplacée dans [publication_list] par <em>descartes_nohighlight</em>): Ne met pas en gras les alias des membre de l\'unité ou de l\'équipe sélectionnée. .</li>
    <li><em>displaytype="[none|with_titles|for_each]"</em> (option remplacée dans [publication_list] par <em>descartes_orga_types</em>): Séléctionne la façon d\'afficher les changement de types de publications.</li>
    <li><em>format="[html_default|html_hal]"</em> (option remplacée dans [publication_list] par <em>descartes_format</em>): Séléctionne la façon d\'afficher les publications.</li>
    </ul>
    <p><strong>Options à items multiples</strong>:</p>
    <ul>
    <li>Les options <em>alias, auteurid, unite, equipe, years</em> peuvent être des choix multiples en séparant les items par le carractère "|".</li>
    </ul>
    <p><strong>Ancienne syntaxe</strong> : [get_publications] (versions &lt;= 0.60)</p>
    ';
    return $to_display;
}
function MonLabo_help_shortcode_teams_list() {
    $to_display="";
    $to_display.='<h3>[teams_list]</h3>';
    $options0=get_option( 'MonLabo_settings_group0' );
    if (isset($options0["MonLabo_uses_members_and_groups"]) && (intval($options0["MonLabo_uses_members_and_groups"])===1)) {
        $to_display.='
        <div style="float:right;"><p><strong>Rendu</strong>:</p>
        <p><a href="'.plugins_url( 'images/teams_list.png', __FILE__ ).'"><img width="300" src="'.plugins_url( 'images/teams_list.png', __FILE__ ).'" alt="exemple" /></a></p></div>
        <p><strong>Où l\'insérer&nbsp;?</strong> Pas d\'endroit spécifique nécessaire.</p>
        <p><strong>Contenu généré</strong> : Liste des équipes avec leur logos et leur thématiques.</p>
        <p><strong>Exemples d\'utilisation</strong>:</p>
        <ul>
        <li><em>[teams_list]</em> :  Affiche la liste de toutes les équipes.</li>
        <li><em>[teams_list group="3,4"]</em> : Affiche la liste de toutes les équipes attachées au groupes d\'équipes n°3 et 4.</li>
        <li><em>[teams_list group="3" teams_publications_page="Mes-publications-d-equipe.php"]</em> : Affiche la liste de toutes les équipes attachées au groupe n°3 et ajoute un lien <em>"Team publication"</em> pointant vers la page Mes-publications-d-equipe.php</li>
        </ul>
        <p><strong>Options</strong> :</p>
        <ul>
        <li><em>group="x"</em> (facultatif) : N\'affiche que la liste des équipes  du groupe d\'équipe au numéro indiqué (x peut être une liste séparée par des vigules)</li>
        <li><em>teams_publications_page="url"</em> (facultatif) : Adresse de renvoi pour l\'affichage optionnel des publications. Ajoute à chaque équipe un lien <em>"Team publication"</em> pointant vers l\'url et ayant comme paramètre <em>"?equipe=N"</em> (N est le numéro de l\'équipe dans la base Descartes Publi).</li>
        </ul>
        ';
    } else {
        $to_display.='<p>Désactivé</p>';
    }
    return $to_display;
}
function MonLabo_help_shortcode_perso_panel() {
    $to_display="";
    $to_display.='<h3>[perso_panel]</h3>';
    $options0=get_option( 'MonLabo_settings_group0' );
    if (isset($options0["MonLabo_uses_members_and_groups"]) && (intval($options0["MonLabo_uses_members_and_groups"])===1)) {
        $to_display.='
        <div style="float:right;"><p><strong>Rendu</strong>:</p>
        <p><a href="'.plugins_url( 'images/perso_panel.png', __FILE__ ).'"><img width="300" src="'.plugins_url( 'images/perso_panel.png', __FILE__ ).'" alt="exemple" /></a></p></div>
        <p><strong>Où l\'insérer&nbsp;?</strong> Au début de chaque page perso d\'un utilisateur.</p>
        <p><strong>Contenu généré</strong> : Insère un encart avec les coordonnées de l\'utilisateur. Les coordonnées sont récupérées depuis la liste des personnels dont le champs "ID page web" correspond à la page perso. L\'image de l\'utilisateur est l\'"image à la une" de la page perso où est insérée cette balise.</p>
        <p><strong>Exemple d\'utilisation</strong>:</p>
        <ul><li><em>[perso_panel]</em></li></ul>
        <p><strong>Options</strong> :</p>
        <ul>
        <li><em>person="x"</em> (facultatif) : force l\'affichage du perso_panel de l\'utilisateur d\'ID x.</li>
        </ul>
        <p><strong>Ancienne syntaxe</strong> [perso_panel_automatic] (versions &lt;= 0.60)</p>
        ';
    } else {
        $to_display.='<p>Désactivé</p>';
    }
    return $to_display;
}
function MonLabo_help_shortcode_team_panel() {
    $to_display="";
    $to_display.='<h3>[team_panel]</h3>';
    $options0=get_option( 'MonLabo_settings_group0' );
    if (isset($options0["MonLabo_uses_members_and_groups"]) && (intval($options0["MonLabo_uses_members_and_groups"])===1)) {
        $to_display.='
        <div style="float:right;"><p><strong>Rendu</strong>:</p>
        <p><a href="'.plugins_url( 'images/team_panel.png', __FILE__ ).'"><img width="300" src="'.plugins_url( 'images/team_panel.png', __FILE__ ).'" alt="exemple" /></a></p></div>
        <p><strong>Où l\'insérer&nbsp;?</strong> Au début de chaque page d\'équipe.</p>
        <p><strong>Contenu généré</strong> : Insère un encart avec le nom de l\'équipe, les chefs d\'équipe et les thématiques. Les informations sont récupérées depuis la liste des équipes dont le champs "ID page web" correspond à la page d\'équipe.</p>
        <p><strong>Exemple d\'utilisation</strong>:</p>
        <p><strong>Options</strong> :</p>
        <ul>
        <li><em>team="x"</em> (facultatif) : force l\'affichage du team_panel de l\'équipe d\'ID x.</li>
        </ul>
        <ul><li><em>[team_panel]</em></li></ul>
        ';
    } else {
        $to_display.='<p>Désactivé</p>';
    }
    return $to_display;
}
///////////////////////////////////////////////////////////////////////////////////////////
//                                  CONFIGURATION MENU
///////////////////////////////////////////////////////////////////////////////////////////
function MonLabo_help_render() {
    require_once( dirname(__FILE__) . '/includes/inc-lib-modals.php' );

    if( isset( $_GET[ 'tab' ] ) ) {  $active_tab = $_GET[ 'tab' ]; }
    else {                           $active_tab = 'tab_functionalities';      }
    $options0=get_option( 'MonLabo_settings_group0' );
    echo('<div class="wrap">');
    echo('<h1>Mini documentation :</h1>');
    echo('<h4>Ce plugin Wordpress permet, sur une interface unifiée, de gérer les pages des équipes et des personnels d’un laboratoire de recherche.<br />Il simplifie la mise à jour des membres et équipes, de leurs informations et leur liste de publication (extraite de HAL ou d’une base de donnée maison comme celle de Paris Descartes).</h4>');
    echo('<p>Ce plugin ajoute les "shortcodes" ci-dessous. Ces "shortcodes" sont à insérer dans les pages pour générer automatiquement des contenus.</p>');
    echo('<ol>');
    echo('<li>Affichage des personnels...');
        echo('<ul>');
            echo('<li>...');
             if (!isset($options0["MonLabo_uses_members_and_groups"]) || ($options0["MonLabo_uses_members_and_groups"]!="1")) { echo('<s>'); }
              echo('qui sont actifs : par liste '.boostrap_info_modal('[members_list]', MonLabo_help_shortcode_members_list()).', par tableau '.boostrap_info_modal('[members_table]', MonLabo_help_shortcode_members_table()).', par organigramme '.boostrap_info_modal('[members_chart]', MonLabo_help_shortcode_members_chart()).'');
             if (!isset($options0["MonLabo_uses_members_and_groups"]) || ($options0["MonLabo_uses_members_and_groups"]!="1")) { echo('</s> (désactivé)'); }
            echo('</li><li>...');
              if (!isset($options0["MonLabo_uses_members_and_groups"]) || ($options0["MonLabo_uses_members_and_groups"]!="1")) { echo('<s>'); }
              echo('qui sont des anciens membres : par liste '.boostrap_info_modal('[alumni_list]', MonLabo_help_shortcode_alumni_list()).', par tableau '.boostrap_info_modal('[alumni_table]', MonLabo_help_shortcode_alumni_table()).', par organigramme '.boostrap_info_modal('[alumni_chart]', MonLabo_help_shortcode_alumni_chart()).'');
              if (!isset($options0["MonLabo_uses_members_and_groups"]) || ($options0["MonLabo_uses_members_and_groups"]!="1")) { echo('</s> (désactivé)'); }
            echo('</li>');
        echo('</ul>');
    echo('</li>');
    if (!isset($options0["MonLabo_uses_members_and_groups"]) || ($options0["MonLabo_uses_members_and_groups"]!="1")) { echo('<s>'); }
    echo('Affichage des équipes par liste '.boostrap_info_modal('[teams_list]', MonLabo_help_shortcode_teams_list()).'');
    if (!isset($options0["MonLabo_uses_members_and_groups"]) || ($options0["MonLabo_uses_members_and_groups"]!="1")) { echo('</s> (désactivé)'); }
    echo('</li><li>');
    if (!isset($options0["MonLabo_uses_members_and_groups"]) || ($options0["MonLabo_uses_members_and_groups"]!="1")) { echo('<s>'); }
    echo('Affichage des publications '.boostrap_info_modal('[publications_list]', MonLabo_help_shortcode_publications_list()).' (requête personnalisée OBSOLETE ==> '.boostrap_info_modal('[custom_publications_list]', MonLabo_help_shortcode_custom_publications_list(), "button-link").')');
    if (!isset($options0["MonLabo_uses_members_and_groups"]) || ($options0["MonLabo_uses_members_and_groups"]!="1")) { echo('</s> (désactivé)'); }
    echo('</li><li>');
    if (!isset($options0["MonLabo_uses_members_and_groups"]) || ($options0["MonLabo_uses_members_and_groups"]!="1")) { echo('<s>'); }
    echo('Affichage de l\'entête des pages personnelles '.boostrap_info_modal('[perso_panel]', MonLabo_help_shortcode_perso_panel()).' ou de l\'entête des pages d\'équipe '.boostrap_info_modal('[team_panel]', MonLabo_help_shortcode_team_panel()).'');
    if (!isset($options0["MonLabo_uses_members_and_groups"]) || ($options0["MonLabo_uses_members_and_groups"]!="1")) { echo('</s> (désactivé)'); }
    echo('</li></ol>');

    $MonLabo_menu_info = get_plugin_data( plugin_dir_path( __FILE__ ) .'../MonLabo.php' );
    $user_data=get_userdata(get_current_user_id());
    if(!empty($user_data)) {
        $user_email=$user_data->data->user_email;
    } else {
        $user_email="";
    }
    echo ('<h1>'.__('Aidez-nous en signalant que vous êtes utilisateur','MonLabo').' :</h1>');
    echo(__('Vous pouvez autoriser les développeurs à publier sur le site du plugin que vous être utilisateur de MonLabo. Cela nous rendra grandement service pour montrer que ce plugin est utilisé.','MonLabo')."<br />");
    echo(__('Site du plugin','MonLabo').' : <a href="'.$MonLabo_menu_info["PluginURI"].'">'.$MonLabo_menu_info["PluginURI"].'</a><br />');
    echo(__('Merci !','MonLabo'));

    echo('<form method="get" action="http://monlabo.org/add_to_registred_users.php">');
    echo('<div class="input-group"><label>'.__('Couriel','MonLabo').' ('.__('facultatif','MonLabo').')</label>');
    echo('<input type=\'text\' name=\'email\' value="'.$user_email.'" />');
    echo('<input type=\'hidden\' name=\'url\' value="'.site_url().'" />');
    echo('<input type=\'hidden\' name=\'version\' value="'.$MonLabo_menu_info['Version'].'" />');
    echo(' &nbsp;&nbsp;<input type="submit" name="submit" id="submit" class="button button-secondary" value="'.__('Indiquez aux auteurs que vous utilisez le plugin sur','MonLabo').' '.site_url().'"  /></div></form>');

    echo ('<h1>'.__('Informez-vous','MonLabo').' :</h1>');
    echo(__("Vous pouvez aussi vous abonner aux listes de diffusion suivantes",'MonLabo')." :<ul>");
    echo("<li><div class='input-group'><label>".__('Annonces MonLabo','MonLabo')."</label> - ".__('pour être au courant des sorties des nouvelles versions','MonLabo').". ".boostrap_button_link(__("S'abonner",'MonLabo'), "https://listes.services.cnrs.fr/wws/subscribe/annonces_monlabo?previous_action=info", "button-secondary")."</div></li>");

    echo("<li><div class='input-group'><label>".__('Liste MonLabo','MonLabo')."</label> - ".__('discussions autour des usages et des évolutions de MonLabo','MonLabo').". ".boostrap_button_link(__("S'abonner",'MonLabo'), "https://listes.services.cnrs.fr/wws/subscribe/monlabo?previous_action=info", "button-secondary")."</div></li>");
    echo('</ul></div>');
}
 ?>
