<?php

if (!defined('WP_PLUGIN_DIR')) exit('No direct script access allowed');

/**
 * Crée le code HTML d'un tableau complet crée à partir des Informations
 * d'un groupe de personnes et destiné à être affiché dans l'inteface d'administration.
 *
 * @param array $status statut des personnes à extraire
 *
 * @return string code HTML
 */
function generate_table_admin_for_persons($status) {
    $generate_HTML = New MonLabo_generate_HTML();
    $MonLabo_access_data = New MonLabo_access_data();
    $persons_information=$MonLabo_access_data->get_persons_information($status);
    $teams_information=$MonLabo_access_data->get_teams_information();
    $options0 = get_option('MonLabo_settings_group0');
    $options2 = get_option('MonLabo_settings_group2');
    $nb_custom_fields=0;
    if (isset($options0["MonLabo_uses_custom_fields_for_staff"]) && (intval($options0["MonLabo_uses_custom_fields_for_staff"])===1)) {
        $options3 = get_option('MonLabo_settings_group3');
        if ($options3["MonLabo_custom_fields_number"]<"1") { $nb_custom_fields=0; }
        elseif ($options3["MonLabo_custom_fields_number"]>"10") { $nb_custom_fields=10;}
        else { $nb_custom_fields=intval($options3["MonLabo_custom_fields_number"]); }
    }
    $colums_titles=Array("", _x("Nom","personne", "MonLabo"), _x("Prénom","personne", "MonLabo"), __("id", "MonLabo"),_x("Titre","personne", "MonLabo"), __("Page", "MonLabo")
                    , __("Logo", "MonLabo"), _x("Catégorie","personne", "MonLabo"), _x("Fonction (fr)", "personne", "MonLabo"), _x( "Fonction (en)","personne", "MonLabo")
                    ,__("Mail", "MonLabo"), __("Téléphone", "MonLabo"), __("Bureau", "MonLabo"), __("Adr. alt.", "MonLabo"), __("URL ext.", "MonLabo"), __("id HAL", "MonLabo")
                    ,__("id Descartes", "MonLabo"), __("login Descates", "MonLabo")
                    , _x("Statut","personne", "MonLabo"), _x("Départ","personne", "MonLabo"), __("Visible", "MonLabo"), __("Équipes", "MonLabo"), __("Tuteurs", "MonLabo")
                );
    for ($i=1; $i <= $nb_custom_fields; $i++) {
        $colums_titles[]="custom".$i;
    }
    $list_array=array();
    $number_of_persons=count($persons_information);
    $a_afficher = "";
    if($number_of_persons!="0") {
        foreach ($persons_information as $person_information) {
            $person_array=array();
            $person_array["modifier"]='<form method="post" action="admin.php?page=MonLabo_edit_members_and_groups&tab=tab_one&submit_item='.$person_information->id.'">'
                                    .'<button type="submit">'.__('Modifier','MonLabo').'</button></form>';
            $person_array["last_name"]=$person_information->last_name;
            $person_array["first_name"]=$person_information->first_name;
            $person_array["id"]=$person_information->id;
            $person_array["title"]=$person_information->title;
            $person_array["wp_post_id"]='<a href="'.get_edit_post_link($person_information->wp_post_id).'&action=edit">'.$person_information->wp_post_id.'</a>';

            $wp_post_id=$person_information->wp_post_id;
            $person_array["logo"]='<a class="hover_zoom_square30">';
            if (has_post_thumbnail($wp_post_id)) {
                  $person_array["logo"].= get_the_post_thumbnail($wp_post_id, 'thumbnail', array( 'class' => 'img-arrondi',  'id'=>"image-preview-'.$person_information->id.'"));
            } elseif  ((!is_numeric($wp_post_id)) and (!empty($person_information->alternate_image))) {
                $person_array["logo"].= '<img id="image-preview-'.$person_information->id.'" src="'.$person_information->alternate_image.'" class="wp-image-6 alignright img-arrondi wp-post-image" alt="'.$person_information->alternate_image.'" />';
            } else {
                //Display default image
                $person_array["logo"].= '<img id="image-preview-'.$person_information->id.'" src="'.$options2['MonLabo_img_par_defaut'].'" class="wp-image-6 alignright img-arrondi wp-post-image" alt="'.$options2['MonLabo_img_par_defaut'].'" />';
            }
            $person_array["logo"].='</a>';

            $person_array["category"]=$person_information->category;
            $person_array["function_fr"]="<small>".$person_information->function_fr."</small>";
            $person_array["function_en"]="<small>".$person_information->function_en."</small>";
            $person_array["mail"]="<small>".$person_information->mail."</small>";
            $person_array["phone"]=$person_information->phone;
            $person_array["room"]=$person_information->room;
            $person_array["address_alt"]=(empty($person_information->address_alt) ? "" : '<small>'.$person_information->address_alt.'</small>');
            $person_array["external_url"]=(empty($person_information->external_url) ? "" : '<a href="'.$person_information->external_url.'">'.__('lien', "MonLabo").'</a>');
            $person_array["hal_publi_author_id"]=$person_information->hal_publi_author_id;
            $person_array["descartes_publi_author_id"]=$person_information->descartes_publi_author_id;
            $person_array["uid_ENT_parisdescartes"]=$person_information->uid_ENT_parisdescartes;
            $person_array["status"]=$person_information->status;
            $person_array["date_departure"]=$person_information->date_departure;
            $person_array["visible"]=$person_information->visible;
            $teams_id=$MonLabo_access_data->get_teams_id_for_a_person($person_information->id);
            if(!empty($teams_id)) {
                $teams_links=Array();
                foreach ($teams_id as $id) {
                    $teams_links[]="<a href='#' title='".$teams_information[$id]->name_fr."'>$id</a>";
                }
                $person_array["equipes"]=((is_array($teams_links)) ? implode(", ",$teams_links): $teams_links);
            } else {
                $person_array["equipes"]="";
            }
            $mentors_name=$MonLabo_access_data->get_mentors_name_for_a_person($person_information->id);
            if(!empty($mentors_name)) {
                $person_array["mentors"]="<small>".((is_array($mentors_name)) ? implode(", ",$mentors_name) : $mentors_name)."</small>";
            } else {
                $person_array["mentors"]="";
            }
            for ($i=1; $i <= $nb_custom_fields; $i++) {
                $nom_variable = "custom".$i;
                $person_array[$nom_variable]=$person_information->$nom_variable;
            }
            $list_array[]=$person_array;
        }
        $a_afficher .= '<div class="MonLabo MonLabo_persons_table_normal">'
                        .$generate_HTML->generic_table("", $colums_titles, $list_array)
                        .'</div>';
    }
    return $a_afficher;
}

/**
 * Crée le code HTML d'un tableau complet crée à partir des Informations
 * d'un groupe d'équipes et destiné à être affiché dans l'inteface d'administration.
 *
 * @return string code HTML
 */
function generate_table_admin_for_teams() {

    $generate_HTML = New MonLabo_generate_HTML();
    $MonLabo_access_data = New MonLabo_access_data();
    $teams_information=$MonLabo_access_data->get_teams_information();
    $options0=get_option( 'MonLabo_settings_group0' );
    $options4 = get_option('MonLabo_settings_group4');

    $colums_titles=Array("", __("id", "MonLabo"),_x("Nom (fr)", "MonLabo"), __("Nom (en)", "MonLabo"),__("Logo", "MonLabo"), __("Pages", "MonLabo"), __("URL ext.", "MonLabo")
                    , __("id HAL", "MonLabo"),__("id Descartes", "MonLabo")
                    , __("Couleur", "MonLabo"), __("Responsables", "MonLabo"), __("Unité", "MonLabo")
                );
    if (isset($options0["MonLabo_uses_thematiques"]) && (intval($options0["MonLabo_uses_thematiques"])===1)) {
        $colums_titles[]= "Thématiques";
    }
    $list_array=array();
    $number_of_teams=count($teams_information);
    $a_afficher = "";

    if($number_of_teams!="0") {
        foreach ($teams_information as $team_information) {
            $team_array=array();
            $team_array["modifier"]='<form method="post" action="admin.php?page=MonLabo_edit_members_and_groups&tab=tab_two">'
                                    .'<input type="hidden" name="submit_equipe" value="'.$team_information->id.'">'
                                    .'<button type="submit">'.__('Modifier','MonLabo').'</button></form>';
            $team_array["id"]=$team_information->id;
            $team_array["name_fr"]="<small>".$team_information->name_fr."</small>";
            $team_array["name_en"]="<small>".$team_information->name_en."</small>";
            $team_array["logo"]=(empty($team_information->logo) ? "" : '<a href="'.$team_information->logo.'" class="hover_zoom_square30"><img src="'.$team_information->logo.'" height="24" alt="'.$team_information->logo.'" /></a>');
            if(!empty($team_information->wp_post_id)) {
                $teams_links=Array();
                foreach (explode(",",$team_information->wp_post_id) as $id) {
                    $teams_links[]='<a href="'.get_edit_post_link($id).'&action=edit">'.$id.'</a>';
                }
                $team_array["wp_post_id"]=( (is_array($teams_links)) ? implode(", ", $teams_links) : $teams_links);
            } else {
                $team_array["wp_post_id"]="";
            }
            $team_array["external_url"]=(empty($team_information->external_url) ? "" : '<a href="'.$team_information->external_url.'">'.__('lien', "MonLabo").'</a>');
            $team_array["hal_publi_team_id"]=$team_information->hal_publi_team_id;
            if(!empty($team_information->descartes_publi_team_id)) {
                $team_array["descartes_publi_team_id"]="<a href='".$options4["MonLabo_DescartesPubmed_api_url"]."?equipe=".$team_information->descartes_publi_team_id."'>"
                                                        .$team_information->descartes_publi_team_id."</a>";
            } else {
                $team_array["descartes_publi_team_id"]="";
            }
            $team_array["color"]=$team_information->color;
            $team_names=$MonLabo_access_data->get_leaders_name_for_a_team($team_information->id);
            $team_array["leaders"]=( (is_array($team_names)) ? implode(", ", $team_names) : $team_names);

            if($team_information->id_unit === MAIN_STRUCT_NO_UNIT) {
                $team_array["id_unit"]=__("Structure principale", "MonLabo");
            } else {
                $team_array["id_unit"]=$team_information->id_unit;
            }

            if (isset($options0["MonLabo_uses_thematiques"]) && (intval($options0["MonLabo_uses_thematiques"])===1)) {
                $thematics_information=$MonLabo_access_data->get_thematics_information_for_a_team($team_information->id);
                if(!empty($thematics_information)) {
                    $thematics_links=Array();
                    foreach ($thematics_information as $thematic) {
                        $thematics_links[]="<a href='#' title='".$thematic->name_fr."'>$thematic->id</a>";
                    }
                    $team_array["thematics"]=((is_array($thematics_links)) ? implode(", ",$thematics_links) : $thematics_links);
                } else {
                    $team_array["thematics"]="";
                }
            }
            $list_array[]=$team_array;
        }
        $a_afficher .= '<div class="MonLabo MonLabo_teams_table_normal">'
                        .$generate_HTML->generic_table("", $colums_titles, $list_array)
                        .'</div>';
    }
    return $a_afficher;
}

/**
 * Crée le code HTML d'un tableau complet crée à partir des Informations
 * d'un groupe de thématiques et destiné à être affiché dans l'inteface d'administration.
 *
 * @return string code HTML
 */
function generate_table_admin_for_thematics() {
    $generate_HTML = New MonLabo_generate_HTML();
    $MonLabo_access_data = New MonLabo_access_data();
    $thematics_information=$MonLabo_access_data->get_thematics_information();
    $colums_titles=Array("", __("id", "MonLabo"),__("Nom (fr)", "MonLabo"), __("Nom (en)", "MonLabo"), __("Logo", "MonLabo"), __("URL ext.", "MonLabo")
                    , __("id HAL", "MonLabo"), __("Équipes", "MonLabo")
                );
    $list_array=array();
    $number_of_thematics=count($thematics_information);
    $a_afficher = "";
    if($number_of_thematics!="0") {
        foreach ($thematics_information as $thematic_information) {
            $thematic_array=array();
            $thematic_array["modifier"]='<form method="post" action="admin.php?page=MonLabo_edit_members_and_groups&tab=tab_three">'
                                    .'<input type="hidden" name="submit_thematic" value="'.$thematic_information->id.'">'
                                    .'<button type="submit">'.__('Modifier','MonLabo').'</button></form>';
            $thematic_array["id"]=$thematic_information->id;
            $thematic_array["name_fr"]="<small>".$thematic_information->name_fr."</small>";
            $thematic_array["name_en"]="<small>".$thematic_information->name_en."</small>";
            $thematic_array["logo"]=(empty($thematic_information->logo) ? "" : '<a href="'.$thematic_information->logo.'" class="hover_zoom_square30"><img src="'.$thematic_information->logo.'" height="24" alt="'.$thematic_information->logo.'" /></a>');
            $thematic_array["external_url"]=(empty($thematic_information->external_url) ? "" : '<a href="'.$thematic_information->external_url.'">'.__('lien', "MonLabo").'</a>');
            $thematic_array["hal_publi_thematic_id"]=$thematic_information->hal_publi_thematic_id;
            $teams_information=$MonLabo_access_data->get_teams_information_for_a_thematic($thematic_information->id);
            if(!empty($teams_information)) {
                $thematics_links=Array();
                foreach ($teams_information as $team) {
                    $teams_links[]="<a href='#' title='".$team->name_fr."'>$team->id</a>";
                }
                $thematic_array["thematics"]=((is_array($teams_links)) ? implode(", ",$teams_links) : $teams_links);
            } else {
                $thematic_array["thematics"]="";
            }
            $list_array[]=$thematic_array;
        }
        $a_afficher .= '<div class="MonLabo MonLabo_thematics_table_normal">'
                        .$generate_HTML->generic_table("", $colums_titles, $list_array)
                        .'</div>';
    }
    return $a_afficher;
}


/**
 * Crée le code HTML d'un tableau complet crée à partir des Informations
 * d'un groupe d'unités et destiné à être affiché dans l'inteface d'administration.
 *
 * @return string code HTML
 */
function generate_table_admin_for_units() {
    /*              `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
                  `affiliations` varchar(200) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                  `code` varchar(50) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                  `name_fr` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                  `name_en` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                  `external_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                  `hal_publi_unit_id` int(11) DEFAULT NULL,
                  */
    $generate_HTML = New MonLabo_generate_HTML();
    $MonLabo_access_data = New MonLabo_access_data();
    $units_information=$MonLabo_access_data->get_units_information();
    $options4 = get_option('MonLabo_settings_group4');
    $colums_titles=Array("",  __("id", "MonLabo"),
                              __("Nom (fr)", "MonLabo"),
                              __("Nom (en)", "MonLabo"),
                              __("logo", "MonLabo"),
                              __("Code", "MonLabo"),
                              __("Affiliations", "MonLabo"),
                              __("URL ext.", "MonLabo"),
                              __("id Descartes", "MonLabo"),
                              __("id HAL", "MonLabo"),
                              __("Adresse alt.", "MonLabo"),
                              __("Contact alt.", "MonLabo"),
                              __("Directeurs", "MonLabo") );
    $list_array=array();
    $number_of_units=count($units_information);
    $a_afficher = "";
    if($number_of_units!="0") {
        foreach ($units_information as $unit_information) {
            $unit_array=array();
            $unit_array["modifier"]='<form method="post" action="admin.php?page=MonLabo_edit_members_and_groups&tab=tab_four">'
                                    .'<input type="hidden" name="submit_unite" value="'.$unit_information->id.'">'
                                    .'<button type="submit">'.__('Modifier','MonLabo').'</button></form>';
            $unit_array["id"]=$unit_information->id;
            $unit_array["name_fr"]="<small>".$unit_information->name_fr."</small>";
            $unit_array["name_en"]="<small>".$unit_information->name_en."</small>";
            $unit_array["logo"]=(empty($unit_information->logo) ? "" : '<a href="'.$unit_information->logo.'" class="hover_zoom_square30"><img src="'.$unit_information->logo.'" height="24" alt="'.$unit_information->logo.'" /></a>');
            $unit_array["code"]=$unit_information->code;
            $unit_array["affiliations"]="<small>".$unit_information->affiliations."</small>";
            $unit_array["external_url"]=(empty($unit_information->external_url) ? "" : '<a href="'.$unit_information->external_url.'">'.__('lien', "MonLabo").'</a>');
            if(!empty($unit_information->descartes_publi_unit_id)) {
                $unit_array["descartes_publi_unit_id"]="<a href='".$options4["MonLabo_DescartesPubmed_api_url"]."?unite=".$unit_information->descartes_publi_unit_id."'>"
                                                        .$unit_information->descartes_publi_unit_id."</a>";
            } else {
                $unit_array["descartes_publi_unit_id"]="";
            }

            $unit_array["hal_publi_unit_id"]=$unit_information->hal_publi_unit_id;
            $unit_array["address_alt"]=$unit_information->address_alt;
            $unit_array["contact_alt"]=$unit_information->contact_alt;
            $directors=$MonLabo_access_data->get_directors_name_for_an_unit($unit_information->id);
            if(!empty($directors)) {
                $unit_array["directors"]=((is_array($directors)) ? implode(", ",$directors): $directors);
            } else {
                $unit_array["directors"]="";
            }
            $list_array[]=$unit_array;
        }
        $a_afficher .= '<div class="MonLabo MonLabo_units_table_normal">'
                        .$generate_HTML->generic_table("", $colums_titles, $list_array)
                        .'</div>';
    }
    return $a_afficher;
}
