//===========================================================
// Fonction lancée lorsque l'on touche à un sélecteur de
// choix de la categorie d'un nouvel auteur.
//===========================================================
function touchCategoryNouvelAuteur(categoryChosen) {
    //Cacher tous les optgroup de submit_fonction
    jQuery("select[name='submit_fonction'] optgroup").hide();
    //Montrer l'optgroup de la categorie choisie
    jQuery("select[name='submit_fonction'] optgroup[label='" + categoryChosen + "']").show();
}
//===========================================================
// Fonction lancée lorsque l'on touche à un sélecteur de
// choix du statut d'un auteur.
//===========================================================
function touchStatusNouvelAuteur() {
    var itemChosen = jQuery("select[name='submit_status']").val();
    if (itemChosen==="actif") {
        jQuery("#MonLabo_dateDepartureForm").hide();
    } else {
        jQuery("#MonLabo_dateDepartureForm").show();
    }
}
//===========================================================
// Fonction lancée lorsque l'on touche à un sélecteur de
// choix des fonctions d'un nouvel auteur.
//===========================================================
function touchFonctionNouvelAuteur(itemChosen) {
    // itemChosen est de la forme "category | function_en | function_fr"
    var fonctions = itemChosen.split(" | ");
    jQuery("input[name='submit_function_en']").val(fonctions[1]);
    jQuery("input[name='submit_function_fr']").val(fonctions[2]);
}
//===========================================================
// Fonction de chagement du thumbnail d'une personne
//===========================================================
function ajax_load_post_thumbnail_now() {
    if (jQuery("#delayedLoadDivThumbnail").length) {
        var data = {
            "action": "update_member_thumbnail",
            "wp_post_id": jQuery("select[name='submit_wp_post_id']").val()
        };

        // We can also pass the url value separately from ajaxurl for front end AJAX implementations
        jQuery.post(ajax_object_update_member_thumbnail.ajax_url, data, function(response) {
            jQuery("#delayedLoadDivThumbnail").hide();
            jQuery("#delayedLoadDivThumbnail").html(response);
            jQuery("#delayedLoadDivThumbnail").fadeIn(500);
        });
    }
}


//===========================================================
// Menu Media pour choisir une image
//===========================================================
function image_media_menu(title_text = "Images",
    button_text = "OK",
    image_preview_field_id = "image-preview",
    image_attachement_url_field_id = "image_attachment_url",
    image_attachement_id_field_id = "image_attachment_id") {
    // Create the media frame.
    var file_frame = wp.media.frames.file_frame = wp.media({
        title: title_text,
        button: {
            text: button_text
        },
        multiple: false // Set to true to allow multiple files to be selected
    });
    var url;
    // When an image is selected, run a callback.
    file_frame.on("select", function() {
        // We set multiple to false so only get one image from the uploader
        var attachment = file_frame.state().get("selection").first().toJSON();
        var url_thubmnail;
        if ((attachment.sizes) && (attachment.sizes.thumbnail) && (attachment.sizes.thumbnail.url)) {
            url_thubmnail = attachment.sizes.thumbnail.url;
        } else {
            url_thubmnail = attachment.url;
        }
        // Do something with attachment.id and/or attachment.url here
        jQuery("#" + image_preview_field_id).attr("src", url_thubmnail).css("width", "auto");
        jQuery("#" + image_preview_field_id).removeAttr("srcset");
        jQuery("#" + image_attachement_url_field_id).val(url_thubmnail);
        jQuery("#" + image_attachement_id_field_id).val(attachment.id);
    });
    // Finally, open the modal
    file_frame.open();
}

//===========================================================
// Affiche les champs d'édition des fonctions des personnels
//===========================================================
function affiche_edition_fonctions_fields() {
    jQuery("#edition_fonctions_fields").show();
}
//===========================================================
// Appui sur le bouton d'édition de wp_post_id
//===========================================================
function affiche_edition_wp_post_id() {
    //Affiche le champs d'édition de l'URL
    jQuery("#edition_wp_post_id_field").show();
    //Le rempli avec le permalien de la page wordpress
    jQuery("input[name='submit_edition_wp_post_id']").val(jQuery("#wp_post_id_post_link").val());
    //Met la sélection à jour
    jQuery("#submit_wp_post_id").val("0");
    //Met à jour le thumbnail
    ajax_load_post_thumbnail_now();
}

//===========================================================
// Efface le champs d'ID image_attachment_url
//===========================================================
function effacer_choix_media(image_preview_field_id = "image-preview",
    image_attachement_url_field_id = "image_attachment_url",
    image_attachement_id_field_id = "image_attachment_id") {
    jQuery("#" + image_attachement_url_field_id).val("");
    jQuery("#" + image_attachement_id_field_id).val("");
    jQuery("#" + image_preview_field_id).attr("src", "").css("width", "auto");
    jQuery("#" + image_preview_field_id).removeAttr("srcset");
}

//=================================================================
// Change une valeur de séléction d'un idem dans la page d'édition
//=================================================================
function change_item(form_id, item_id) {
    //On rajoute en _GET le numero de membre pour le récupérer en cas de rechargement de la page
    jQuery("#" + form_id).attr("action", jQuery(location).attr("href") + "&submit_item=" + item_id);
    document.forms[form_id].submit(); //On valide le formulaire et recharge la page
}

function change_member(val) {
    change_item("choix_membre", val);
}

function change_team(val) {
    change_item("choix_equipe", val);
}

function change_thematic(val) {
    change_item("choix_thematique", val);
}

function change_unite(val) {
    change_item("choix_unite", val);
}

//=================================================================
// Edite ou supprime un membre ou une structure
//=================================================================
function submit_form(form_id, action) {
    document.getElementById("action").value = action; //On programme l'action au rechargement de la page
    if (jQuery("#form_edit_member").length) {
        affiche_edition_fonctions_fields(); //On affiche les champs cachés pour comprendre pourquoi le submit est refusé s'ils sont vides
    }
    document.forms[form_id].submit(); //On valide le formulaire et recharge la page
}

function edit_member() {
    submit_form("form_edit_member", "edit");
}

function remove_member() {
    submit_form("form_edit_member", "remove");
}

function edit_team() {
    submit_form("form_edit_team", "edit");
}

function remove_team() {
    submit_form("form_edit_team", "remove");
}

function edit_thematic() {
    submit_form("form_edit_thematic", "edit");
}

function remove_thematic() {
    submit_form("form_edit_thematic", "remove");
}

function edit_unite() {
    submit_form("form_edit_unite", "edit");
}

function remove_unite() {
    submit_form("form_edit_unite", "remove");
}

//================================================
//Actions faites lorsque la page a fini de charger
//================================================
jQuery(document).ready(function($) {
    jQuery(".my-color-field").wpColorPicker();

    ajax_load_post_thumbnail_now();

    //On affiche le formulaire d'édition de wp_post_id si celui ci a déjà été édité
    if (document.getElementById("wp_post_id_edited")) {
        if (jQuery("#wp_post_id_edited").val().length != 0) {
            jQuery("#edition_wp_post_id_field").show();
        }
    }

    //Configurations pour la page d'édition des membres
    if (jQuery("#form_edit_member").length) {
        category = jQuery("select[name='submit_category']").val();
        touchCategoryNouvelAuteur(category);
        fonctions = jQuery("select[name='submit_fonction']").val();
        touchFonctionNouvelAuteur(fonctions);
    }

    //Active la fonction touchStatusNouvelAuteur si le selecteur status est touché
    touchStatusNouvelAuteur();
    jQuery("select[name='submit_status']").on("change", touchStatusNouvelAuteur );

});
