<?php
/*
class MonLabo_generate_HTML {

    //General LIBRAIRY
    obsfuscate_email ($email)                                                   DONE

    //Extract person's items
    person_name ($person_information)                                           DONE TESTED
    person_teams_enumeration ($person_information, $langage, $separator=", ")   DONE TESTED

    //Build sets of persons
    persons_list($title_single, $title_plural, $persons_information, $language) DONE TESTED
    persons_table_compact_column ($persons_information, $title, $language) DONE TESTED
    persons_table_normal ($main_title, $colums_titles, $persons_information, $language, $titles_color, $status)    DONE TESTED
    person_panel ($person_information, $teams_id, $mentors_information, $students_information, $language)    DONE TESTED
    team_panel ($team_information, $leaders_information, $thematics_name, $language, $color)

    //Generic functions
    generic_table ($main_title, $colums_titles, $HTML_content_array, $column_titles_color, $table_title_color);           DONE TESTED
    generic_list ($main_title, $HTML_content_list, $class_of_li);               DONE TESTED
*/

//For use function is_plugin-active()
include_once( ABSPATH . 'wp-admin/includes/plugin.php' );

class MonLabo_generate_HTML {

    public function __construct() {
    }

    //--------------------------------------------------------------------------------
    // Obsfuscate email adress in order to avoid spam
    //--------------------------------------------------------------------------------
    // $email   => email to encode
    //--------------------------------------------------------------------------------
    function obsfuscate_email($email) {
        // separate out the host and the name
        if ($email!=""){
            $parts = explode('@', $email );
            $email= '<span class="MonLabo_email">' . $parts[0] . '&#64;<span>-'.__('Code a retirer pour éviter le SPAM', "MonLabo").'-</span>' . $parts[1] . '</span>';
        }
        return $email;
    }

    /**
     * Crée le lien URL en fonction de wp_post_id
     *
     * @return Si wp_post_id est numérique
     *                  ?p=wp_post_id
     *         Sinon
     *                  wp_post_id
     */
    function transform__wp_post_id__into_url($wp_post_id) {
        if (empty($wp_post_id) or (!is_numeric($wp_post_id))) {
            //wp_post_id a été éditée à la main et remplacée par une URL
            return $wp_post_id;
        } else {
            //C'est une URL wordpress a reconstituer
            return site_url().'/?p='.$wp_post_id;
        }
    }

    /**
     * Crée le code HTML d'un nom d'une personne cliquable
     *
     * @return Si wp_post_id n'est pas vide
     *              Si wp_post_id est numérique
     *                  <a href="?p=wp_post_id">Prenom NOM</a>
     *              Sinon
     *                  <a href="wp_post_id">Prenom NOM</a>
     *         sinon
     *              Prenom NOM
     *
     */
     public function person_name($person_information){
        if (!isset($person_information->id)) { return "";}
        $name=MonLaboLib::to_html($person_information->first_name) . " ". MonLaboLib::strtoupper_to_html($person_information->last_name);

        $is_alumni=false;
        if(property_exists($person_information, "status")) {
            $is_alumni=(strtolower($person_information->status) === "alumni");
        }
        if ((!$is_alumni) and (property_exists($person_information, "wp_post_id")) and (!empty($person_information->wp_post_id))) {
             $link_to_display='<a href="'.$this->transform__wp_post_id__into_url($person_information->wp_post_id). '" class=\'MonLaboLink\'>';
             $end_link_to_display="</a>";
         } elseif ((property_exists($person_information, "wp_post_id")) and (!empty($person_information->external_url))) {
             $link_to_display='<a href="' .$person_information->external_url . '" class=\'MonLaboLink\'>';
             $end_link_to_display="</a>";
         } else {
             $link_to_display="";
             $end_link_to_display="";
         }

        return $link_to_display.$name.$end_link_to_display;
    }

    /**
     * Crée le code HTML d'un nom d'équipe cliquable
     *
     * @param string $language langue d'affichage
     *
     * @return Si wp_post_id n'est pas vide
     *              <a href="?p=ID">nom_de_l'equipe</a>
     *         sinon
     *              Si external_url n'est pas vide
     *                  <a href="external_url">nom_de_l'equipe</a>
     *              sinon
     *                  nom_de_l'equipe
     *
     */
     public function team_name_in_html( $team_information, $language, $with_logo = false ) {
        switch ( $language ) {
            case "en-US":
            case "en-GB":
                $name = "name_en";
                break;
            default: //"fr-FR"
                $name = "name_fr";
        }
        //$wp_post_id = $team_information->wp_post_id;
        if (empty($team_information)){
            return "";
        }
        $wp_post_ids = explode(",",$team_information->wp_post_id);
        $wp_post_id = $wp_post_ids[0];
        // Prepare picture of the team
        if (($team_information->logo != "") && $with_logo) {
            $team_logo = "<img src='".$team_information->logo."' class='wp-image-8 alignleft wp-post-image team_logo' height='70' width='70' alt=' ' />";
        } else {
            $team_logo = "";
        }
        $href = "";
        if( $wp_post_id != "" ) {
            $post_id = $wp_post_id;
            $href = site_url()."/?p=".$post_id;
        } elseif ( ($team_information->wp_post_id === "" ) && ($team_information->external_url!="")){
            $href = $team_information->external_url;
        }
        /*
         * acronyme des noms d'équipes (LISSI)
        $masque = "/[A-Z]/";
        preg_match_all($masque, $team_information->$name, $matches);
        $team_name_abbreviated = implode("", $matches[0]);
        */
        $team_name_abbreviated = MonLaboLib::to_html($team_information->$name);
        if ( $href != "" ) {
            $team_name = "<a href='" . $href . "' class='MonLaboLink'>" . $team_logo . $team_name_abbreviated . "</a>";
        } else {
            $team_name = $team_logo . $team_name_abbreviated;
        }
        return $team_name;
    }

    /**
     * Crée le code HTML d'une liste d'équipes d'une personne
     *
     * @param array $persons_information tableau d'information sur les personnes
     * @param string $language langue d'affichage
     * @param string $separator séparateur entre chaque équipe
     *
     * @return string code HTML
     */
    public function person_teams_enumeration( $person_information, $language, $separator = ", " ) {
        $MonLabo_access_data = New MonLabo_access_data();

        if ( !isset( $person_information->id ) ) { return ""; }
        $teams = $MonLabo_access_data->get_teams_information_for_a_person( $person_information->id );
        if ( $teams === NULL ) {
            return "";
        } else {
            $teams_description = array();
            foreach ($teams as $team) {
                $teams_description[$team->id] = $this->team_name_in_html( $team, $language );
            }
        }
        asort($teams_description); //Mettre les équipes dans l'ordre de leur ID.
        return "<span class='team_description'>".implode($separator,$teams_description)."</span>";
    }

    /**
     * Crée le code HTML d'une adresse d'une personne
     *
     * @param array $persons_information tableau d'information sur les personnes
     * @param string $language langue d'affichage
     *
     * @return string code HTML
     */
    public function person_address_HTML( $person_information, $language ) {
        $a_afficher="";
        if ( !isset( $person_information->id ) ) { return ""; }
        if (strlen($person_information->address_alt)>0) {
            // 1-  Si une adresse alternative est précisée pour la personne, alors l'utiliser
            // ------------------------------------------------------------------------------
            $a_afficher .=  '<div class="adresse"><p>'.nl2br(MonLaboLib::to_html($person_information->address_alt)).'</p></div>';
        } else {
            // 2- Par défaut utiliser l'adresse de la structure principale
            // -----------------------------------------------------------
            $options0 = get_option( 'MonLabo_settings_group0' );
            $options1 = get_option( 'MonLabo_settings_group1' );
            $labo_adresse=$options1['MonLabo_adresse'];
            $labo_contact=$options1['MonLabo_contact'];
            $labo_nom=$options1['MonLabo_nom'];
            $labo_code=$options1['MonLabo_code'];

            // 3- Si une unité est précisée, utiliser les coordonnées de cette unité
            // ---------------------------------------------------------------------
            if (isset($options0["MonLabo_uses_unites"]) && (intval($options0["MonLabo_uses_unites"])===1)) {
                if ( isset( $person_information->id ) ) {
                    $MonLabo_access_data = New MonLabo_access_data();
                    $teams = $MonLabo_access_data->get_teams_information_for_a_person( $person_information->id );
                    if(!empty($teams)) {
                        $first_team=reset($teams);
                        if (isset( $first_team->id)) {
                            if ($first_team->id_unit > 0) {
                                //Regardons l'unité de la première équipe de la personne
                                $unit=$MonLabo_access_data->get_unit_information($first_team->id_unit);
                                if (isset( $unit->id)) {
                                     if(strlen($unit->address_alt)>0){
                                        //Une adresse alternative d'unité est précisée? Alors l'utiliser.
                                        $labo_adresse=$unit->address_alt;
                                    }
                                    if(strlen($unit->contact_alt)>0){
                                        //Un contact alternatif d'unité est précisé? Alors l'utiliser.
                                        $labo_contact=$unit->contact_alt;
                                    }
                                    //récupérer le nom et le code de l'unité
                                    switch ($language) {
                                        case "en-GB" :
                                        case "en-US" :
                                            $labo_nom=$unit->name_en;
                                            break;
                                        default : // fr
                                            $labo_nom=$unit->name_fr;
                                    }
                                    $labo_code=$unit->code;
                                }
                            }
                        }
                    }
                }
            }
            //Forger l'adresse
            $a_afficher .=  '<div class="adresse"><p>'.MonLaboLib::to_html($labo_nom.' - '.$labo_code).'<br />'
                            .nl2br(MonLaboLib::to_html($labo_adresse)).'</p>'
                            .'<p>'.MonLaboLib::to_html($labo_contact).'</p></div>';
        }
        return $a_afficher;
    }



    /*
     * Crée le code HTML d'un organigramme crée à partir des Informations
     * d'un groupe de personnes.
     *
     * @param string $unit_name nom de la structure
     * @param array $directors liste des directeurs de la structure
     * @param array $teams_information liste des equipes de la structure
     * @param array $persons_information[category][team] tableau d'information sur les personnes
     * @param string $language langue d'affichage
     *
     * @return string code HTML
     */
    function persons_chart( $unit_name, $directors, $teams_information, $persons_information_by_category_and_team, $language ) {
        $generate_HTML = New MonLabo_generate_HTML();
        switch ($language) {
            case "en-US":
            case "en-GB":
                $lang="en";
                $name="name_en";
                break;
            default: //"fr-FR"
                $lang="fr";
                $name="name_fr";
        }
        //TODO filtrer les invisibles
        $number_of_persons=count($persons_information_by_category_and_team);
        $a_afficher = "";
        if( $number_of_persons != "0" ) {
            $a_afficher .= "<table class=\"MonLabo_persons_chart\">";
            $directors_name = array();
            if(count($directors)>0) {
                foreach ( $directors as $director ) {
                    $directors_name[] = $generate_HTML->person_name($director);
                }
                $a_afficher .= "<caption>".MonLaboLib::to_html($unit_name)."<br />"."Direction : ".implode( " &amp; ", $directors_name )."</caption>";
            } else {
                if(!empty($unit_name)) {
                    $a_afficher .= "<caption>".MonLaboLib::to_html($unit_name)."</caption>";
                }
            }

            $a_afficher .= "<tr>";
            foreach ( $teams_information as $team_id=>$team_information ) {
                $style='';
                if(!empty($team_information->color)) {
                    $style=" style='color:#FFF; background-color:".$team_information->color.";'";
                }
                $a_afficher .= "<td class=\"team_$team_id\"".$style.">";
                $a_afficher .= MonLaboLib::to_html($team_information->$name);
                $a_afficher .= "</td>";
            }
            $a_afficher .= "</tr>";
            $categories = array_keys( $persons_information_by_category_and_team );
            foreach ( $categories as $category ) {
                $a_afficher .= "<tr>";
                foreach ( $teams_information as $team_id=>$team_information ) {
                    $style='';
                    if(!empty($team_information->color)) {
                        $style=" style='color:".$team_information->color.";'";
                    }
                    $translated_title =  MonLabo_translate::translate( ucfirst($category),$language );
                    $a_afficher .= "<td class=\"team_$team_id\"".$style.">";
                    $a_afficher .= MonLaboLib::to_html($translated_title);
                    $a_afficher .= "</td>";
                }
                $a_afficher .= "</tr>";
                $a_afficher .= "<tr>";
                foreach ( $teams_information as $team_id=>$team_information ) {

                    $a_afficher .= "<td>";
                    if(     (array_key_exists($category,             $persons_information_by_category_and_team))
                        and (array_key_exists($team_information->id, $persons_information_by_category_and_team[$category]))) {
                        $members = $persons_information_by_category_and_team[$category][$team_information->id];
                        if ( !empty( $members ) ) {
                            foreach ( $members as $member ) {
                                if (strcmp($member->visible, "non") != 0) {  // supprime les personnes qui doivent être invisible
                                    if ( (property_exists($member, "leader")) and ($member->leader)) {
                                        $a_afficher .= "<strong>".$generate_HTML->person_name($member).'</strong>';
                                    } else {
                                        $a_afficher .= $generate_HTML->person_name($member);
                                    }
                                }
                                //If member is alumni, tells it
                                $alumni_str=$this->alumni_function($member, $language);
                                if (!empty($alumni_str)){
                                    $a_afficher .='<small>'.$alumni_str.'</small>';
                                }
                                $a_afficher .='<br />';
                            }
                        }
                    }
                    $a_afficher .= "</td>";
                }
                $a_afficher .= '</tr>';
                $a_afficher .= '<tr>';
                foreach ( $teams_information as $team_information ) {
                    $style='';
                    if(!empty($team_information->color)) {
                        $style=" style='border-top-color:".$team_information->color.";'";
                    }
                    $a_afficher .= '<td>';
                    $a_afficher .= '<hr'.$style.' />';
                    $a_afficher .= '</td>';
                }
                $a_afficher .= '</tr>';
            }
            $a_afficher .= '</table>';
        }
        return $a_afficher;
    }

    /**
     * Crée le code HTML d'un tableau complet crée à partir des Informations
     * d'un groupe de personnes.
     *
     * @param string $main_title Titre à afficher en haut du tableau
     * @param array $colums_titles liste des titres des colonnes ([ clé_de_colonne => "titre de colonne"])
     * @param array $persons_information tableau d'information sur les personnes
     * @param string $language langue d'affichage
     * @param string $titles_color couleur des titres
     * @param string $status statut des personnes
     *
     * @return string code HTML
     */
    function persons_table_normal($main_title, $columns_titles, $persons_information, $language, $titles_color='', $status="actif") {
        $generate_HTML = New MonLabo_generate_HTML();
        $MonLabo_persons = New MonLabo_persons($persons_information);
        $list_array=array();
        //Traduction des colonnes
        $translated_titles=array();
        foreach ($columns_titles as $title) {
            $translated_titles["column_".$title]=MonLabo_translate::translate(ucfirst($title),$language);
        }
        //Recupère la bonne fonction en fonction du language
        switch ($language) {
            case "en-US":
            case "en-GB":
                $function="function_en";
                break;
            default: //"fr-FR"
                $function="function_fr";
        }
        $MonLabo_persons->suppress_non_visible();
        $a_afficher = "";
        if($MonLabo_persons->count()!="0") {
            $person_array=array();
            foreach ($MonLabo_persons->get_persons() as $person_information) {
                if(($status==="all") or ($person_information->status===$status)){
                    $person_array["Nom"]=$generate_HTML->person_name($person_information);
                    if ($person_information->status === "alumni") {
                        if(!empty($person_information->date_departure)){
                            $person_array["Nom"].= MonLaboLib::to_html(" (". MonLabo_translate::translate(lcfirst($person_information->$function),$language)." ".MonLabo_translate::translate("until",$language)." ".$person_information->date_departure.")");
                        } else {
                            $person_array["Nom"].= MonLaboLib::to_html(" (".MonLabo_translate::translate("former")." ". MonLabo_translate::translate(lcfirst($person_information->$function),$language)." ".MonLabo_translate::translate("until",$language).")");
                        }
                    }
                    $person_array["Equipe"]=$generate_HTML->person_teams_enumeration($person_information, $language);
                    $person_array["Email"]=$this->obsfuscate_email($person_information->mail);
                    $person_array["Tel"]=MonLaboLib::to_html(MonLaboLib::get_phone_with_prefix($person_information->phone));
                    $list_array[]=$person_array;
                }
            }
            $a_afficher .= '<div class="MonLabo MonLabo_persons_table_normal">'
                            .$generate_HTML->generic_table(MonLabo_translate::translate(ucfirst($main_title),$language), $translated_titles, $list_array, '', $titles_color)
                            .'</div>';
        }
        return $a_afficher;
    }


    /**
     * Crée le code HTML d'une colonne d'un tableau compact crée à partir des Informations
     * d'un groupe de personnes.
     *
     * @param array $persons_information tableau d'information sur les personnes
     * @param string $title titre de la colonne
     * @param string $language langue d'affichage
     * @param string $column_titles_color couleur des titres des colonnes
     *
     * @return string code HTML
     */
    function persons_table_compact_column($persons_information, $title, $language, $column_titles_color='') {
        $generate_HTML = New MonLabo_generate_HTML();
        $MonLabo_persons = New MonLabo_persons($persons_information);
        $a_afficher = "";
        $MonLabo_persons->suppress_non_visible();
        if($MonLabo_persons->count()>0) {
            //0 - Initialisations
            $person_array=array();
            $all_ordered_categories=get_MonLabo_persons_categories();
            $person_array[$title]="<ul>";

            // 2 - Classement des personnes par catégories
            foreach ($MonLabo_persons->get_persons() as $person_information) {
                $person_array[$title] .="<li>".$generate_HTML->person_name($person_information)."</li>";
            }
            // 3 - Fermeture de toutes les balises <ul>
            $person_array[$title].="</ul>";

            // 4 - Traduction du titre
            $translated_categories=array();
            $translated_categories[$title]=MonLaboLib::to_html(MonLabo_translate::translate(ucfirst($title),$language));

            $a_afficher .= '<div class="MonLabo MonLabo_persons_table_compact">'.$generate_HTML->generic_table(NULL, $translated_categories, array($person_array), $column_titles_color).'</div>';
        }
        return $a_afficher;
    }

    /**
     * Crée le code HTML d'une liste de personnes crée à partir des Informations
     * d'un groupe de personnes.
     *
     * @param string $title_single titre de la liste si celle si ne comporte qu'une personne
     * @param string $title_plural titre de la liste si celle si comporte plusieurs personnes
     * @param array $persons_information tableau d'information sur les personnes
     * @param string $language langue d'affichage
     *
     * @return string code HTML
     */
    public function persons_list($title_single, $title_plural, $persons_information, $language) {
        $generate_HTML = New MonLabo_generate_HTML();
        $a_afficher = "";
        $MonLabo_persons = New MonLabo_persons($persons_information);
        $MonLabo_persons->suppress_non_visible();
        if($MonLabo_persons->count()!="0") {
            $number_of_persons=0;
            $person_array=array();
            foreach ($MonLabo_persons->get_persons() as $person_information) {
                $list_item=$this->generate_HTML_person_small_panel($person_information, $language);
                if ($list_item!=""){
                    $HTML_content_list[]=$list_item;
                    $number_of_persons++;
                }
            }
            if ($number_of_persons>0) {
                if ($number_of_persons===1) {
                    $adapted_title=MonLabo_translate::translate(ucfirst($title_single),$language);
                } else {
                    $adapted_title=MonLabo_translate::translate(ucfirst($title_plural),$language);
                }
                $HTML_full_list=$generate_HTML->generic_list($adapted_title, $HTML_content_list, "MonLaboUser");
                if ($HTML_full_list!="") {
                    $a_afficher .= '<div class="MonLabo MonLabo_persons_list">'.$HTML_full_list.'</div>';
                }
            }
        }
        return $a_afficher;
    }

    /**
     * Crée le code HTML d'une liste d'équipe crée à partir des informations
     * d'un groupe d'équipe.
     *
     * @param int $thematic thematique pour laquelle on veut afficher les équipes
     * @param array $teams_leaders[$team_id] tableau des noms des chefs d'équipes
     * @param array $teams_information tableau d'information sur les équipes
     * @param array $thematics_information[$team_id] tableau d'information sur les thematiques des équipes
     *              ([ nom_de_l_information => valeur_de_l_information])
     * @param string $teams_publications_page page où se trouvent les publictations
     * @param string $language langue d'affichage
     *
     * @return string code HTML
     */
    public function teams_list( $thematic, $teams_information, $teams_leaders, $thematics_information, $teams_publications_page, $language ) {
        $generate_HTML = New MonLabo_generate_HTML();
        $a_afficher = "";
        switch ($language) {
            case "en-US":
            case "en-GB":
                $nom="name_en";
                break;
            default: //"fr-FR"
                $nom="name_fr";
        }

        if( count($teams_information) !=  "0" ) {
            $a_afficher .= '<div class="teams_list">';
            $a_afficher .= '<ul>';
            foreach ($teams_information as $team_information) {
                // Preparation du nom avec un lien vers la page d'équipe si elle existe
                $team_name_in_html = $this->team_name_in_html( $team_information, $language, true );
                //Prepare pictures of the other thematics
                $logos_other_thematics='';
                if ( is_array( $thematics_information[$team_information->id] ) ) {
                    $logos_other_thematics .= "<div class='teams_list_other_thematics_logos'>";
                    foreach ( $thematics_information[$team_information->id] as $other_thematic ) {
                        if ( $other_thematic->id != $thematic ){
                            $logos_other_thematics .= "<a href='".$other_thematic->external_url."' class='MonLaboLink' title='Other thematic of the team : ";
                            $logos_other_thematics .= MonLaboLib::to_html($other_thematic->$nom)."'><img src='".$other_thematic->logo;
                            $logos_other_thematics .= "' class='thematics_logo' alt=' '></a>";
                        }
                    }
                    $logos_other_thematics .= "</div>";
                }

                $a_afficher .= "<li>".$logos_other_thematics."<div class='team_list_item'><h4>" . $team_name_in_html ."</h4>" ;
                if(!empty($teams_leaders)) {
                    if(!empty($team_information)){
                        if(!empty($teams_leaders[$team_information->id])){
                            $a_afficher .=  "Direction : " . MonLaboLib::to_html(implode( " & ", $teams_leaders[$team_information->id] ));
                        }
                    }
                }
                if ($teams_publications_page != "") {
                    $a_afficher .= "<div class='teams_list_publications_link'><a href='".$teams_publications_page."?equipe=";
                    $a_afficher .= $team_information->descartes_publi_team_id."' class='MonLaboLink'>Team publications</a></div>";
                }
                $a_afficher .= "</div></li>";
            }
            $a_afficher .= "</ul>";
            $a_afficher .= "</div>";
        }
        return $a_afficher;
    }


    /**
     * Crée le code HTML d'une personne dans une liste à partir des Informations
     * de cette personne
     *
     * @param array $person_information informations sur cette personne
     * @param string $language langue d'affichage
     * @param string $picture Si précisé, utilise $picture pour l'image de la personne
     *
     * @return string code HTML
     */
    public function generate_HTML_person_small_panel($person_information, $language, $picture="") {
        $a_afficher = "";
        $MonLabo_generate_HTML=New MonLabo_generate_HTML();
        $MonLabo_access_data=New MonLabo_access_data();

        //Get the text data for the user
        //-----------------------------
        switch ($language) {
            case "en-US":
            case "en-GB":
                $function=$person_information->function_en;
                break;
            default: //"fr-FR"
                $function=$person_information->function_fr;
        }

        $is_alumni=(strtolower($person_information->status) === "alumni");

        //function generate_HTML_for_list_user(
        //$external_link="") {
        if ($person_information->visible!='non'){
            $options2 = get_option( 'MonLabo_settings_group2' );

            //Prepare picture of the user
            //---------------------------
            if ($picture==="") {
                $image=$this->get_the_person_thumbnail($person_information, 70, 70, "wp-image-8 alignleft img-arrondi");
            } else {
                $image='<img src="'.$picture.'" class="wp-image-8 alignleft img-arrondi wp-post-image" height="70" width="70" alt=" " />';
            }

            //Prepare link
            //------------
            if ((!$is_alumni) && (!empty($person_information->wp_post_id))) {
                $link_to_display='<a href="'.$this->transform__wp_post_id__into_url($person_information->wp_post_id). '" class=\'MonLaboLink\'>';
                $end_link_to_display="</a>";
            } elseif (!empty($person_information->external_url)) {
                $link_to_display='<a href="' .$person_information->external_url . '" class=\'MonLaboLink\'>';
                $end_link_to_display="</a>";
            } else {
                $link_to_display="";
                $end_link_to_display="";
            }

            //Generate the HTML code
            //----------------------
            $a_afficher.='<div class="MonLaboImageUser">' . $link_to_display . $image . $end_link_to_display . "</div>";
            $a_afficher.='<div class="MonLaboTextUser">'.$link_to_display . '<strong>' . MonLaboLib::to_html($person_information->first_name) . " " . MonLaboLib::strtoupper_to_html($person_information->last_name) . "</strong>". $end_link_to_display;
            if(!empty($function)) {
                if ($is_alumni) {
                    if ($person_information->date_departure!="") {
                        $a_afficher.=', <em>' . MonLaboLib::to_html($function. ' '.MonLabo_translate::translate('until',$language).' '.$person_information->date_departure).'</em>';
                    } else {
                        $a_afficher.=', <em>'.MonLaboLib::to_html(MonLabo_translate::translate('Former',$language).' ' . $function). '</em>';
                    }
                } else {
                    $a_afficher.=', <em>' . MonLaboLib::to_html($function). '</em>';
                }
            }
            $teams_enumeration=$this->person_teams_enumeration($person_information, $language);
            if(!empty($teams_enumeration)) {
                $a_afficher.= ", ".$teams_enumeration;
            }

            $a_afficher.='<br /><div class="MonLaboCoordonatesUser">';
            $list_to_display=Array(); //On range les items suivants dans un tableau
            if ($person_information->mail<>'') { $list_to_display[] = $MonLabo_generate_HTML->obsfuscate_email($person_information->mail); }
            if ($person_information->phone<>'') { $list_to_display[] = MonLaboLib::to_html(MonLaboLib::get_phone_with_prefix($person_information->phone)); }
            if ((!$is_alumni) && ($person_information->room<>'')) { $list_to_display[] = MonLaboLib::to_html(MonLabo_translate::translate('room',get_bloginfo('language')) .' ' . $person_information->room); }
            $a_afficher.=implode(", ", $list_to_display); //On met des virgules entre chaque item
            $a_afficher.= '</div></div>';
        }
        return $a_afficher;
    }

    /**
     * Crée le code HTML d'un tableau générique crée à partir d'un array et de titres
     *
     * @param string $main_title Titre à afficher en haut du tableau
     * @param array $colums_titles liste des titres des colonnes ([ Classe_de_colonne(optionnel) => "titre de colonne"])
     * @param array $HTML_content_array contenu du tableau
     * @param array $column_titles_color couleur des titres de colonnes
     * @param array $table_title_color couleur du titre de la table
     *
     * @return string code HTML
     */
    function generic_table($main_title, $colums_titles, $HTML_content_array, $column_titles_color='', $table_title_color='') {
        $a_afficher ='';
        if ((!(empty($HTML_content_array))) or (!empty($colums_titles))) {
            $titleColorText='';
            if(!empty($table_title_color)) {
                $titleColorText=' style="color:'.$table_title_color.';"';
            }
            if ((isset($main_title)) and (strlen($main_title)>0)) {
                $a_afficher .= "<a id='".str_replace(' ', '_', $main_title)."'></a>"; //Anchor
                $a_afficher .= "<h1".$titleColorText.">".MonLaboLib::to_html($main_title)."</h1>";
            }
            $a_afficher .= '<table>';
            if (!empty($colums_titles)) { //If title is empty => Do not display
                $colorText='';
                if(!empty($column_titles_color)) {
                    $colorText=' style="color:'.$column_titles_color.';"';
                }
                $a_afficher .= '<thead><tr>';
                foreach ($colums_titles as $class=>$title) {
                    if (is_int($class)) {
                      $classText="";
                    } else {
                      $classText=' class="'.$class." ".strtolower($class).'"';
                    }
                    $a_afficher .= '<th scope="col"'.$classText.$colorText.'>'.MonLaboLib::to_html($title).'</th>';
                }
                $a_afficher .= '</tr></thead>';
            }

            if (!empty($HTML_content_array)) { //If content is empty => Do not display
                $a_afficher .= '<tbody>';
                foreach ($HTML_content_array as $line) {
                    if (!empty($line)) {
                        $a_afficher .= '<tr>';
                        foreach ($line as $cell) {
                            $a_afficher .= '<td>'.$cell.'</td>';
                        }
                        $a_afficher .= '</tr>';
                    }
                }
                $a_afficher .= '</tbody>';
            }
            $a_afficher .= '</table>';
        }
        return $a_afficher;
    }

    /**
     * Crée le code HTML d'une liste générique crée à partir d'un array et de titres
     *
     * @param string $main_title Titre à afficher en haut de la liste
     * @param array $HTML_content_list array du contenu de la liste
     * @param string $class_of_li classe optionnelle à rajouter aux éléements de type li
     *
     * @return string code HTML
     */
    function generic_list($main_title, $HTML_content_list, $class_of_li="") {
        $a_afficher ='';
        if ((isset($main_title)) and (strlen($main_title)>0) and (!empty($HTML_content_list))) {
            $a_afficher .= "<a id='".str_replace(' ', '_', $main_title)."'></a>"; //Anchor
            $a_afficher .= "<h1>".MonLaboLib::to_html($main_title)."</h1>"; //Title
        }
        if (!empty($HTML_content_list)) { //If content is empty => Do not display
            $a_afficher .= '<ul>';
            foreach ($HTML_content_list as $line) {
                if (!empty($line)) {
                    if ($class_of_li!="") {
                        $a_afficher .= '<li class="'.$class_of_li.'">';
                    } else {
                        $a_afficher .= '<li>';
                    }
                    $a_afficher .= $line.'</li>';
                }
            }
            $a_afficher .= '</ul>';
        }
        return $a_afficher;
    }

    function get_the_person_thumbnail($person_information, $width=70, $height=70, $class="wp-image-6 alignleft img-arrondi"){
        $options2 = get_option( 'MonLabo_settings_group2' );
        $image = get_the_post_thumbnail($person_information->wp_post_id, array($width,$height), array('class'    => $class));
        if ($image==="") { //If no exist display a dummy face
            if ((!is_numeric($person_information->wp_post_id)) and (!empty($person_information->alternate_image))) {
                $image_url=$person_information->alternate_image;
            } else {
                $image_url=$options2['MonLabo_img_par_defaut'];
            }
            $image='<img src="'.$image_url.'" class="'.$class.' wp-post-image" height="'.$height.'" width="'.$width.'" alt=" " />';
        }
        return $image;
    }

    /**
     * Crée le code HTML d'un bandeau de page personnelle
     *
     * @param mixed $person_information structure d'information sur la personne
     * @param array $mentors_information tableau des informations des superviseurs
     * @param array $students_information tableau des informations des étudiants
     * @param string $language langue d'affichage
     *
     * @return string code HTML
     */
    public function person_panel($person_information, $mentors_information, $students_information, $language) {
        switch ($language) {
            case "en-US":
            case "en-GB":
                $function=$person_information->function_en;
                break;
            default: //"fr-FR"
                $function=$person_information->function_fr;
        }
        $room_name=MonLaboLib::to_html(MonLabo_translate::translate('room',$language));
        $title=MonLaboLib::to_html($person_information->title);

        $mail=$this->obsfuscate_email($person_information->mail);
        $phone=MonLaboLib::to_html(MonLaboLib::get_phone_with_prefix($person_information->phone));
        $door=$person_information->room;
        $external_url=$person_information->external_url;
        $options2 = get_option( 'MonLabo_settings_group2' );

        $image=$this->get_the_person_thumbnail($person_information, 150, 150, "wp-image-6 alignleft img-arrondi");
        //Generate HTML
        //------------
        $a_afficher="";
        $a_afficher .= '<div class="bandeau-personnel MonLaboUser">';
        $a_afficher .= $image;
        $a_afficher .= $this->person_address_HTML($person_information, $language);
        $a_afficher .= '<div class="monlaboBlocTexte">';
        $a_afficher .= '<h1>';
        if ($title<>'') { $a_afficher .= $title . ' ';   }

        //If member is alumni, tells it
        $alumni_str=$this->alumni_function($person_information, $language);

        $a_afficher .= $person_information->first_name." ".MonLaboLib::strtoupper_to_html($person_information->last_name).$alumni_str;
        $a_afficher .= '</h1><p class="coordonnees"><em>' . $function;
        $a_afficher .= '</em><br />';
        $a_afficher .= $this->person_teams_enumeration($person_information, $language);
        $a_afficher .= '<br /><br />';
        if ($mail<>'') { $a_afficher .= ''.$mail .'<br />'; }
        if ($phone<>'') { $a_afficher .= $phone; }
        if ($door<>'') { if ($phone<>'') { $a_afficher .= ', '; }
        $a_afficher .=  $room_name.' ' . $door ; }
        if ($external_url<>'') {
            $a_afficher .= '<div class="external_url"><h1 style="text-align: center;">'
                            .'<a href="'. $external_url . '">'
                            .'<button class="btn btn-oldstyle" type="button">'.MonLabo_translate::translate("Personal website",$language).'</button></a></h1></div>';
        }
        $MonLabo_mentors = New MonLabo_persons($mentors_information);
        $MonLabo_mentors->suppress_non_visible();
        if ($MonLabo_mentors->count()>0) {
            $mentors_translate = "";
			if ($MonLabo_mentors->count()===1) {
                $mentors_translate=MonLabo_translate::translate('Supervisor',$language);
            } else {
                $mentors_translate=MonLabo_translate::translate('Supervisors',$language);
            }
            $a_afficher .= '<div class="supervisor"><h1>'.MonLaboLib::to_html($mentors_translate).' : </h1>';
            $first = true;
            $mentors_list = "";
            foreach ($MonLabo_mentors->get_persons() as $mentor) {
                $mentor_name=$this->person_name($mentor);
                if ($first) {
                    $mentors_list .= $mentor_name;
                    $first = false;
                } else {
                    $mentors_list .= "<br />".$mentor_name;
                }
            }
            $a_afficher .= $mentors_list.'</div>';
        }

        $MonLabo_students = New MonLabo_persons($students_information);
        $MonLabo_students->suppress_non_visible();
        if ($MonLabo_students->count()>0) {
            $students_translate = "";
            if ($MonLabo_students->count()===1) {
                $students_translate=MonLabo_translate::translate('Supervised student',$language);
            } else {
                $students_translate=MonLabo_translate::translate('Supervised students',$language);
            }
            $a_afficher .= '<div class="supervisor"><h1>'.MonLaboLib::to_html($students_translate).' : </h1>';
            $first = true;
            $students_list = "";
            foreach ($MonLabo_students->get_persons() as $student) {
                $student_name=$this->person_name($student);
                if ($first) {
                    $students_list .= $student_name;
                    $first = false;
                } else {
                    $students_list .= "<br />".$student_name;
                }
            }
            $a_afficher .= $students_list.'</div>';
        }
        $a_afficher .='</div></div>';
        return $a_afficher;
    }

    /**
     * Crée le code HTML de la fonction d'un alumni
     *
     * @param array $person_information tableau des informations de la personne
     * @param string $language langue d'affichage
     *
     * @return string code HTML
     */
    public function alumni_function($person_information, $language) {
        if (strtolower($person_information->status) === "alumni"){
            $alumni_str="<br /><em>(";
            if ($person_information->date_departure!=""){
                $alumni_str.=MonLaboLib::to_html(MonLabo_translate::translate("alumni since",$language)." ".$person_information->date_departure).")</em>";
            } else {
                $alumni_str.=MonLaboLib::to_html(MonLabo_translate::translate("alumni",$language)).")</em>";
            }
        } else {
            $alumni_str="";
        }
        return $alumni_str;
    }

    /**
     * Crée le code HTML d'un bandeau de page d'équipe
     *
     * @param mixed $team_information structure d'information sur l'équipe
     * @param array $leaders_information tableau des informations des chefs de l'équipe
     * @param array $thematics_information tableau des informations des thématiques de l'équipe
     * @param string $language langue d'affichage
     * @param string $color couleur du titre de l'équipe
     *
     * @return string code HTML
     */
    public function team_panel($team_information, $leaders_information, $thematics_name, $language, $color="") {
        switch ($language) {
            case "en-US":
            case "en-GB":
                $team_name = MonLaboLib::to_html($team_information->name_en);
                break;
            default: //"fr-FR"
                $team_name = MonLaboLib::to_html($team_information->name_fr);
        }
        //Generate HTML
        //------------
        $colorText="";
        if(!empty($color)){
            $colorText=' style="color:'.$color.';"';
        } else {
            if(!empty($team_information->color)){
                $colorText=' style="color:'.$team_information->color.';"';
            }
        }
        $a_afficher="<h2".$colorText.">".$team_name."</h2>";
        $a_afficher .= '<div class="bandeau-equipe">';
        if (is_array($thematics_name) and count($thematics_name)>0) {
            $a_afficher .= '<div class="thematics"><h1>';
            $thematics_translate = "";
            if (count($thematics_name)===1) {
                $thematics_translate=MonLabo_translate::translate('Thematic',$language);
            } else {
                $thematics_translate=MonLabo_translate::translate('Thematics',$language);
            }
            $a_afficher .= MonLaboLib::to_html($thematics_translate).' : </h1>';
            $first = true;
            $thematics_list = "";
            foreach ($thematics_name as $thematic_name) {
                if ($first) {
                    $thematics_list .= $thematic_name;
                    $first = false;
                } else {
                    $thematics_list .= "<br />".$thematic_name;
                }
            }
            $a_afficher .= $thematics_list."</div>";
        }
        $MonLabo_leaders = New MonLabo_persons($leaders_information);
        $MonLabo_leaders->suppress_non_visible();
        if ($MonLabo_leaders->count()>0) {
            $a_afficher .= '<h1>';
            $leaders_translate = "";
            if ($MonLabo_leaders->count()===1) {
                $leaders_translate=MonLabo_translate::translate('Team leader',$language);
            } else {
                $leaders_translate=MonLabo_translate::translate('Team leaders',$language);
            }
            $a_afficher .= MonLaboLib::to_html($leaders_translate).' : </h1>';
            $first = true;
            $leaders_list = "";
            foreach ($MonLabo_leaders->get_persons() as $leader) {
                $leader_name=$this->person_name($leader);
                if ($first) {
                    $leaders_list .= $leader_name;
                    $first = false;
                } else {
                    $leaders_list .= "<br />".$leader_name;
                }
            }
            $a_afficher .= $leaders_list;
        }
        $a_afficher .='</div>';
        return $a_afficher;
    }
}
